<?php
namespace Teknisa\CNC\Controllers;

use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO\Request;
use Teknisa\CNC\Services;
use Teknisa\CNC\Utilities;

class Cnc01100SimuacaoAntecipada extends \Zeedhi\Framework\Controller\Simple {
    protected $simulaAntService;
    protected $salesMessage;
    protected $util;
    
    public function __construct(Services\Cnc01100SimuacaoAntecipada $simulaAntService, Utilities\SalesMessageCNC $salesMessage, Utilities\Util $util) {
        $this->simulaAntService  = $simulaAntService;
        $this->salesMessage  = $salesMessage;
        $this->util = $util;
    }

    public function getAnticipatedSimulation(Request\Filter $request, Response $response) {
    	$allFieldsLabel = 'NMADQUIRENTE|NMESTABELEC|VRBRUTVENDA|VRLIQVENDA|NMPRODUTOADQ|CDLOTEVENDA|CDNSU|CDCUPOM|DTLOTE|DTVENDA|DTCREDITO|VRTAXAADM';

	    try {
	        $row = $request->getFilterCriteria()->getConditions();
			
			$conditions = $this->util->getParamsAsArray($request);

			$this->util->setTCDcondition($conditions, 'NRESTABELEC');
			$this->util->setTCDcondition($conditions, 'NRADQUIRENTE');
			$this->util->setTCDcondition($conditions, 'NRPRODUTOADQ');
			
			$this->util->setTCDcondition($conditions, 'CDLOTEVENDA');
			$this->util->setTCDcondition($conditions, 'CDNSU');
			
            $conditions["DTVENDAINI"]  = $conditions['DTVENDA'][0];
            $conditions["DTVENDAFIN"]  = $conditions['DTVENDA'][1];
			unset($conditions['DTVENDA']);
            
			$conditions['DTCREDITOINI'] = $conditions['DTCREDITO'][0];
			$conditions['DTCREDITOFIN'] = $conditions['DTCREDITO'][1];
			unset($conditions['DTCREDITO']);
			
			$this->util->setAllFields($conditions, $allFieldsLabel);
			
            $result = $this->simulaAntService->getAnticipatedSimulation($conditions);
            $response->addDataSet(new DataSet('Cnc01100_ValoresSimuladosRepo', $result));
	    } catch (\Exception $e) {
            $response->addMessage(new Message($e->getMessage()));
	    }
    }

    public function getAnticipatedParametrizedSimulation(Request\Filter $request, Response $response){
        try {
            $params = $request->getFilterCriteria()->getConditions();

            $resultado = $this->simulaAntService->getAnticipatedParametrizedSimulation($params);
            $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('Cnc01100_ValoresSimProcedureRepo', $resultado));

        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), $e->getCode()));
        }
    }
}