<?php
namespace Teknisa\CNC\Factories;

use Doctrine\ORM\EntityManager;

class Cnc01900RelTaxaVendaFactory {
    
    protected $connection;
    
    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
    }

    public function getTaxaVendaCheckFiltered($params, $query){
        $sql = $query; 
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function getTaxaVendaCheck ($params) {
        $sql = "SELECT TO_CHAR(RV.DTVENDA, 'DD/MM/YYYY') DTVENDA, RV.CDNSU, RV.VRTAXAADM, RV.VRBRUTVENDA, RV.VRLIQVENDA, RV.VRTAXAPREV, 
                 E.NRESTABELEC, E.CDESTABELEC, E.NMESTABELEC, A.NRADQUIRENTE, A.NMADQUIRENTE, P.NMPRODUTOADQ, (:DTVENDAINI||' A '||:DTVENDAFIN) PERIODO 
                 FROM RETVENDAADQ RV, PRODUTOADQ P, ESTABELECIMENTO E, ADQUIRENTE A
                   WHERE RV.NRORG = :NRORG 
                    AND RV.NRESTABELEC = :P_NRESTABELEC 
                    AND RV.NRADQUIRENTE = :P_NRADQUIRENTE 
                    AND RV.DTVENDA BETWEEN :DTVENDAINI AND :DTVENDAFIN 
                    AND ((INSTR (:P_NRPRODUTOADQ, RV.NRPRODUTOADQ) > 0) OR ('T' = :P_TNRPRODUTOADQ))
                    AND P.NRPRODUTOADQ = RV.NRPRODUTOADQ 
                    AND E.NRESTABELEC = RV.NRESTABELEC 
                    AND A.NRADQUIRENTE = RV.NRADQUIRENTE 
                 ORDER BY RV.DTVENDA, RV.VRBRUTVENDA, RV.CDNSU";
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
}