<?php

namespace Teknisa\CNC\Factories;

use Doctrine\ORM\EntityManager;

class Cnc02100VendasAntecipadasReportFactory {
    protected $connection;

    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
    }

    public function validateReport ($params) {
        $sql = "SELECT COUNT(*) COUNT FROM
                  (SELECT TO_CHAR(RF.DTVENDA, 'DD/MM/YYYY') DTVENDA, TO_CHAR(RF.DTCREDITO, 'DD/MM/YYYY') DTCREDITO,
                     RF.CDNSU, RF.IDSTATUSVENDA, RF.VRBRUTVENDA, 
                     RF.VRCOBRADOTAXA, RF.VRTAXAANT, RF.VRTAXAANTVENDA, RF.VRLIQPGTO, P.NMPRODUTOADQ, 
                     (:INI || ' A ' || :FIN) PERIODO, E.NMESTABELEC, A.NMADQUIRENTE
                    FROM RETVENDAADQ RV, RETFINANCADQ RF, PRODUTOADQ P, ESTABELECIMENTO E, ADQUIRENTE A
                    WHERE RF.NRORG = :NRORG
                      AND RF.NRESTABELEC = :NRESTABELEC
                      AND RF.NRADQUIRENTE = :NRADQUIRENTE
                      AND RF.DTVENDA BETWEEN :DTVENDA_INI AND :DTVENDA_FIN
                      AND ((INSTR (:NRPRODUTOADQ, '_'||RF.NRPRODUTOADQ||'_') > 0) OR ('T' = :NRPRODUTOADQ))
                      AND ((RF.VRBRUTVENDA BETWEEN :VRVENDA_MIN AND :VRVENDA_MAX) OR ('T' = :VRVENDA))
                      AND RV.CDNSU = RF.CDNSU
                      AND RV.NRADQUIRENTE = RF.NRADQUIRENTE
                      AND RV.DTVENDA = RF.DTVENDA
                      AND RV.NRPRODUTOADQ = P.NRPRODUTOADQ
                      AND RV.NRESTABELEC = E.NRESTABELEC
                      AND RV.NRADQUIRENTE = A.NRADQUIRENTE
                      AND RF.IDSTATUSVENDA = 'A'
                      AND RF.VRTAXAANT IS NOT NULL
                    ORDER BY RV.DTVENDA, RF.VRLIQPGTO, RV.CDNSU)";

        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll()[0]["COUNT"];
    }
}