<?php

namespace Teknisa\CNC\Query;

class Query {

    public function __construct(){

    }

	public static function getConst($const){
        return constant('self::'.$const);
    }
    
    const GET_ACQUIRES = "
        SELECT DAT.NRADQUIRENTE, DAT.NMADQUIRENTE, DAT.CDADQUIRENTEEXT, DAT.CDADQUIRENTE||' - '||DAT.NMADQUIRENTE AS LABELPRODUTOADQ, 
        N FROM 
                (SELECT D.*, ROWNUM as N FROM 
                    (SELECT NRADQUIRENTE, NMADQUIRENTE, CDADQUIRENTE, CDADQUIRENTEEXT, CDADQUIRENTE||' - '||NMADQUIRENTE AS LABELADQUIRENTE 
                    FROM ADQUIRENTE 
                    WHERE IDVISIVEL = 'S'
                        AND IDATIVO = 'S'
                        AND ((INSTR(UPPER(NMADQUIRENTE), UPPER(:ALL_FIELDS)) <> 0) OR :TALL_FIELDS = 'T')
                    ) D 
                ) DAT 
            ORDER BY LABELPRODUTOADQ
    ";
    
    const GET_FLAGS = "
        SELECT DAT.NRBANDEIRAVAN, DAT.NMBANDEIRA, DAT.CDBANDEIRA, DAT.CDBANDEIRA||' - '||DAT.NMBANDEIRA AS LABELBANDEIRA, 
        N FROM 
                (SELECT D.*, ROWNUM as N FROM 
                    (SELECT NRBANDEIRAVAN, NMBANDEIRA, CDBANDEIRA, CDBANDEIRA||' - '||NMBANDEIRA AS LABELBANDEIRA, NRORG
                    FROM BANDEIRAVAN 
                    WHERE UPPER (CDBANDEIRA||' - '||NMBANDEIRA) LIKE UPPER (:LABELBANDEIRA)
                        AND IDVISIVEL = 'S'
                        AND IDATIVO = 'S'
                    ) D 
                ) DAT 
        WHERE DAT.NRORG = :NRORG
            ORDER BY LABELBANDEIRA
    ";
    
    const LOAD_FLAG_BY_NAME = "
        SELECT NRBANDEIRAVAN 
        FROM BANDEIRAVAN 
        WHERE NMBANDEIRA = :NMBANDEIRA
    ";
    
    const GET_STANDARS = "
        SELECT V.NRADQUIRENTE, DECODE(V.NRDIASTOL, NULL , 0, V.NRDIASTOL) NRDIASTOL,
            V.IDNSU, V.IDNSUPOS, V.IDTOLERANCIA, V.IDAUTORIZACAO, 
            DECODE(V.IDBANCO||V.IDAGENCIA||V.IDCONTCORR, 'SSS', 'S', 'N') DADOSBANCO, 
            V.IDPRODUTOADQ, V.IDADQUIRENTE, V.IDBANDEIRA, V.IDEXIGEVRIGUAL, V.IDAJUSTEAUT, V.IDDTVENCIMENTO
        FROM VALIDACAOADQ V JOIN ADQUIRENTE ADQ
            ON V.NRADQUIRENTE = ADQ.NRADQUIRENTE
        WHERE V.NRADQUIRENTE = :NRADQUIRENTE
    ";
    
    const GET_ESTABELEC_STANDARTS = "
        SELECT V.NRVALIDACAOADQEST, V.NRADQUIRENTE, V.NRESTABELEC, V.NRORDEM, 
            DECODE(V.NRDIASTOL, NULL , 0,  V.NRDIASTOL) NRDIASTOL, V.IDNSU, 
            V.IDNSUPOS, V.IDTOLERANCIA, V.IDAUTORIZACAO, 
            DECODE(V.IDBANCO||V.IDAGENCIA||V.IDCONTCORR, 'SSS', 'S', 'N') DADOSBANCO, 
            V.IDPRODUTOADQ, V.IDADQUIRENTE, V.IDBANDEIRA, V.IDEXIGEVRIGUAL, V.IDAJUSTEAUT, V.NRORG, 
            V.IDDTVENCIMENTO
        FROM VALIDACAOADQEST V 
        JOIN ADQUIRENTE ADQ 
            ON V.NRADQUIRENTE = ADQ.NRADQUIRENTE 
        WHERE V.NRADQUIRENTE = :NRADQUIRENTE 
            AND V.NRESTABELEC = :NRESTABELEC
    ";
    
    const GET_ORDERS_STANDARD = "
        SELECT V.NRORDEM, DECODE(V.NRDIASTOL, NULL , 0, V.NRDIASTOL) NRDIASTOL, V.NRVALIDACAOADQ, 
            V.NRADQUIRENTE, V.IDNSU, V.IDNSUPOS, V.IDTOLERANCIA, V.IDAUTORIZACAO, 
            DECODE(V.IDBANCO||V.IDAGENCIA||V.IDCONTCORR, 'SSS', 'S', 'N') DADOSBANCO, 
            V.IDPRODUTOADQ, V.IDADQUIRENTE, V.IDBANDEIRA, V.IDEXIGEVRIGUAL, V.IDAJUSTEAUT, V.IDDTVENCIMENTO
         FROM VALIDACAOADQ V JOIN ADQUIRENTE ADQ
            ON V.NRADQUIRENTE = ADQ.NRADQUIRENTE
        WHERE V.NRADQUIRENTE = :NRADQUIRENTE
            AND V.NRVALIDACAOADQ = :NRVALIDACAOADQ
    ";
    
    //@TODO -> CHECK: GET_ESTAB_STAND E GET_ESTABELEC_STANDARTS
    const GET_ESTAB_STAND = "
        SELECT V.NRORDEM, V.NRVALIDACAOADQEST, V.NRADQUIRENTE, V.NRESTABELEC, 
            DECODE(V.NRDIASTOL, NULL , 0, V.NRDIASTOL) NRDIASTOL, V.IDNSU, V.IDNSUPOS, V.IDTOLERANCIA, 
            V.IDAUTORIZACAO, DECODE(V.IDBANCO||V.IDAGENCIA||V.IDCONTCORR, 'SSS', 'S', 'N') DADOSBANCO, 
            V.IDPRODUTOADQ, V.IDADQUIRENTE, V.IDBANDEIRA, V.IDEXIGEVRIGUAL, V.IDAJUSTEAUT, V.IDDTVENCIMENTO
        FROM VALIDACAOADQEST V JOIN ADQUIRENTE ADQ
            ON V.NRADQUIRENTE = ADQ.NRADQUIRENTE
        WHERE V.NRADQUIRENTE = :NRADQUIRENTE
            AND V.NRESTABELEC = :NRESTABELEC
            AND V.NRVALIDACAOADQEST = :NRVALIDACAOADQEST
    ";
    
    const VALIDATE_ORDER_STANDARTS_INS = "
        SELECT V.NRORDEM, DECODE(V.NRDIASTOL, NULL , 0, V.NRDIASTOL) NRDIASTOL, 
            V.NRVALIDACAOADQ, V.NRADQUIRENTE, V.IDNSU, V.IDNSUPOS, V.IDTOLERANCIA, V.IDAUTORIZACAO, 
            DECODE(V.IDBANCO||V.IDAGENCIA||V.IDCONTCORR, 'SSS', 'S', 'N') DADOSBANCO, 
            V.IDPRODUTOADQ, V.IDADQUIRENTE, V.IDBANDEIRA, V.IDEXIGEVRIGUAL, V.IDAJUSTEAUT, V.IDDTVENCIMENTO
        FROM VALIDACAOADQ V JOIN ADQUIRENTE ADQ
            ON V.NRADQUIRENTE = ADQ.NRADQUIRENTE
        WHERE V.NRADQUIRENTE = :NRADQUIRENTE
            AND V.NRORDEM = :NRORDEM
    ";
    
    const VALIDATE_ORDER_STANDARTS_UPDT = "
        SELECT V.NRORDEM, DECODE(V.NRDIASTOL, NULL , 0, V.NRDIASTOL) NRDIASTOL, 
            V.NRVALIDACAOADQ, V.NRADQUIRENTE, V.IDNSU, V.IDNSUPOS, V.IDTOLERANCIA, V.IDAUTORIZACAO, 
            DECODE(V.IDBANCO||V.IDAGENCIA||V.IDCONTCORR, 'SSS', 'S', 'N') DADOSBANCO, 
            V.IDPRODUTOADQ, V.IDADQUIRENTE, V.IDBANDEIRA, V.IDEXIGEVRIGUAL, V.IDAJUSTEAUT, V.IDDTVENCIMENTO
        FROM VALIDACAOADQ V JOIN ADQUIRENTE ADQ
            ON V.NRADQUIRENTE = ADQ.NRADQUIRENTE
        WHERE V.NRADQUIRENTE = :NRADQUIRENTE
            AND V.NRORDEM = :NRORDEM
            AND V.NRVALIDACAOADQ <> :NRVALIDACAOADQ
    ";
    
    const GET_ORDER_STANDARTS = "
        SELECT V.NRORDEM, DECODE(V.NRDIASTOL, NULL , 0, V.NRDIASTOL) NRDIASTOL, 
            V.NRVALIDACAOADQ, V.NRADQUIRENTE, V.IDNSU, V.IDNSUPOS, V.IDTOLERANCIA, V.IDAUTORIZACAO, 
            DECODE(V.IDBANCO||V.IDAGENCIA||V.IDCONTCORR, 'SSS', 'S', 'N') DADOSBANCO, 
            V.IDPRODUTOADQ, V.IDADQUIRENTE, V.IDBANDEIRA, V.IDEXIGEVRIGUAL, V.IDAJUSTEAUT, V.IDDTVENCIMENTO
        FROM VALIDACAOADQ V JOIN ADQUIRENTE ADQ
            ON V.NRADQUIRENTE = ADQ.NRADQUIRENTE
        WHERE V.NRADQUIRENTE = :NRADQUIRENTE
            AND V.NRORDEM IS NOT NULL
    ";
    
    const VALIDATE_ORDER_STANDARTS_EST_INS = "
        SELECT V.NRORDEM, DECODE(V.NRDIASTOL, NULL , 0, V.NRDIASTOL) NRDIASTOL, 
            V.NRVALIDACAOADQEST, V.NRADQUIRENTE, V.NRESTABELEC, V.IDNSU, V.IDNSUPOS, V.IDTOLERANCIA, 
            V.IDAUTORIZACAO, DECODE(V.IDBANCO||V.IDAGENCIA||V.IDCONTCORR, 'SSS', 'S', 'N') DADOSBANCO, 
            V.IDPRODUTOADQ, V.IDADQUIRENTE, V.IDBANDEIRA, V.IDEXIGEVRIGUAL, V.IDAJUSTEAUT, V.IDDTVENCIMENTO
        FROM VALIDACAOADQEST V JOIN ADQUIRENTE ADQ
            ON V.NRADQUIRENTE = ADQ.NRADQUIRENTE
        WHERE V.NRADQUIRENTE = :NRADQUIRENTE
            AND V.NRESTABELEC = :NRESTABELEC
            AND V.NRORDEM = :NRORDEM
    ";
    
    const VALIDATE_ORDER_STANDARTS_EST_UPDT = "
        SELECT V.NRORDEM, DECODE(V.NRDIASTOL, NULL , 0, V.NRDIASTOL) NRDIASTOL, 
            V.NRVALIDACAOADQEST, V.NRADQUIRENTE, V.NRESTABELEC, V.IDNSU, V.IDNSUPOS, V.IDTOLERANCIA, 
            V.IDAUTORIZACAO, DECODE(V.IDBANCO||V.IDAGENCIA||V.IDCONTCORR, 'SSS', 'S', 'N') DADOSBANCO, 
            V.IDPRODUTOADQ, V.IDADQUIRENTE, V.IDBANDEIRA, V.IDEXIGEVRIGUAL, V.IDAJUSTEAUT, V.IDDTVENCIMENTO
        FROM VALIDACAOADQEST V JOIN ADQUIRENTE ADQ
            ON V.NRADQUIRENTE = ADQ.NRADQUIRENTE
        WHERE V.NRADQUIRENTE = :NRADQUIRENTE
            AND V.NRESTABELEC = :NRESTABELEC
            AND V.NRORDEM = :NRORDEM
            AND V.NRVALIDACAOADQEST <> :NRVALIDACAOADQEST
    ";
    
    const GET_ORDER_STANDARTS_EST = "
        SELECT V.NRORDEM, DECODE(V.NRDIASTOL, NULL , 0, V.NRDIASTOL) NRDIASTOL, 
            V.NRVALIDACAOADQEST, V.NRADQUIRENTE, V.NRESTABELEC, V.IDNSU, V.IDNSUPOS, V.IDTOLERANCIA, 
            V.IDAUTORIZACAO, DECODE(V.IDBANCO||V.IDAGENCIA||V.IDCONTCORR, 'SSS', 'S', 'N') DADOSBANCO, 
            V.IDPRODUTOADQ, V.IDADQUIRENTE, V.IDBANDEIRA, V.IDEXIGEVRIGUAL, IDAJUSTEAUT, V.IDDTVENCIMENTO
        FROM VALIDACAOADQEST V JOIN ADQUIRENTE ADQ
            ON V.NRADQUIRENTE = ADQ.NRADQUIRENTE
        WHERE V.NRADQUIRENTE = :NRADQUIRENTE
            AND V.NRESTABELEC = :NRESTABELEC
            AND V.NRORDEM IS NOT NULL
    ";
    
    const GET_ORDER_STANDARTS_CAD = "
        SELECT V.NRORDEM, DECODE(V.NRDIASTOL, NULL , 0, V.NRDIASTOL) NRDIASTOL, 
            V.NRVALIDACAOADQ, V.NRADQUIRENTE, V.IDNSU, V.IDNSUPOS, V.IDTOLERANCIA, V.IDAUTORIZACAO, 
            DECODE(V.IDBANCO||V.IDAGENCIA||V.IDCONTCORR, 'SSS', 'S', 'N') DADOSBANCO, 
            V.IDPRODUTOADQ, V.IDADQUIRENTE, V.IDBANDEIRA, V.IDEXIGEVRIGUAL, V.IDAJUSTEAUT, V.IDDTVENCIMENTO
        FROM VALIDACAOADQ V JOIN ADQUIRENTE ADQ
            ON V.NRADQUIRENTE = ADQ.NRADQUIRENTE
        WHERE V.NRADQUIRENTE = :NRADQUIRENTE
            AND V.NRORDEM = :NRORDEM
    ";
    
    const GET_ORDER_STANDARTS_EST_CAD = "
        SELECT V.NRORDEM, DECODE(V.NRDIASTOL, NULL , 0, V.NRDIASTOL) NRDIASTOL, 
            V.NRVALIDACAOADQEST, V.NRADQUIRENTE, V.NRESTABELEC, V.IDNSU, V.IDNSUPOS, V.IDTOLERANCIA, V.IDAUTORIZACAO, 
            DECODE(V.IDBANCO||V.IDAGENCIA||V.IDCONTCORR, 'SSS', 'S', 'N') DADOSBANCO, 
            V.IDPRODUTOADQ, V.IDADQUIRENTE, V.IDBANDEIRA, V.IDEXIGEVRIGUAL, IDAJUSTEAUT, V.IDDTVENCIMENTO
        FROM VALIDACAOADQEST V JOIN ADQUIRENTE ADQ
            ON V.NRADQUIRENTE = ADQ.NRADQUIRENTE
        WHERE V.NRADQUIRENTE = :NRADQUIRENTE
            AND V.NRESTABELEC = :NRESTABELEC
            AND V.NRORDEM = :NRORDEM
    ";
    
    const UPDATE_ORDERS_STANDARTS = "
        UPDATE VALIDACAOADQ
            SET IDNSU       = :IDNSU,
            IDNSUPOS        = :IDNSUPOS,
            IDTOLERANCIA    = :IDTOLERANCIA,
            IDBANCO         = :IDBANCO,
            IDAGENCIA       = :IDAGENCIA,
            IDCONTCORR      = :IDCONTCORR,
            IDPRODUTOADQ    = :IDPRODUTOADQ,
            IDADQUIRENTE    = :IDADQUIRENTE,
            IDBANDEIRA      = :IDBANDEIRA,
            IDAJUSTEAUT     = :IDAJUSTEAUT,
            NRORDEM         = :NRORDEM,
            NRDIASTOL       = :NRDIASTOL,
            IDDTVENCIMENTO  = :IDDTVENCIMENTO
        WHERE NRADQUIRENTE  = :NRADQUIRENTE
            AND NRVALIDACAOADQ = :NRVALIDACAOADQ
    ";
    
    const UPDATE_ORDERS_STANDARTS_EST = "
        UPDATE VALIDACAOADQEST
            SET IDNSU       = :IDNSU,
                IDNSUPOS        = :IDNSUPOS,
                IDTOLERANCIA    = :IDTOLERANCIA,
                IDBANCO         = :IDBANCO,
                IDAGENCIA       = :IDAGENCIA,
                IDCONTCORR      = :IDCONTCORR,
                IDPRODUTOADQ    = :IDPRODUTOADQ,
                IDADQUIRENTE    = :IDADQUIRENTE,
                IDBANDEIRA      = :IDBANDEIRA,
                IDAJUSTEAUT     = :IDAJUSTEAUT,
                NRORDEM         = :NRORDEM,
                NRDIASTOL       = :NRDIASTOL,
                IDDTVENCIMENTO  = :IDDTVENCIMENTO
        WHERE NRADQUIRENTE  = :NRADQUIRENTE
                AND NRESTABELEC   = :NRESTABELEC
                AND NRVALIDACAOADQEST = :NRVALIDACAOADQEST
    ";
    
    const INSERT_ORDER_STANDARTS = "
        INSERT INTO VALIDACAOADQ
            (IDNSU, IDNSUPOS, IDTOLERANCIA, IDBANCO, IDAGENCIA, IDCONTCORR, IDPRODUTOADQ, IDADQUIRENTE, 
            IDBANDEIRA, IDAJUSTEAUT, NRVALIDACAOADQ,  NRORDEM, NRDIASTOL, NRADQUIRENTE, IDDTVENCIMENTO) 
        VALUES
            (:IDNSU, :IDNSUPOS, :IDTOLERANCIA, :IDBANCO, :IDAGENCIA, :IDCONTCORR, :IDPRODUTOADQ, :IDADQUIRENTE,
            :IDBANDEIRA, :IDAJUSTEAUT, :NRVALIDACAOADQ, :NRORDEM, :NRDIASTOL, :NRADQUIRENTE, :IDDTVENCIMENTO)
    ";
    
    const INSERT_ORDER_STANDARTS_EST = "
        INSERT INTO VALIDACAOADQEST
            (IDNSU, IDNSUPOS, IDTOLERANCIA, IDBANCO, IDAGENCIA, IDCONTCORR, IDPRODUTOADQ, IDADQUIRENTE,
            IDBANDEIRA, IDAJUSTEAUT, NRVALIDACAOADQEST,  NRORDEM, NRDIASTOL, NRADQUIRENTE, NRESTABELEC,
            IDDTVENCIMENTO) 
        VALUES
            (:IDNSU, :IDNSUPOS, :IDTOLERANCIA, :IDBANCO, :IDAGENCIA, :IDCONTCORR, :IDPRODUTOADQ, :IDADQUIRENTE,
            :IDBANDEIRA, :IDAJUSTEAUT, :NRVALIDACAOADQEST, :NRORDEM, :NRDIASTOL, :NRADQUIRENTE, :NRESTABELEC,
            :IDDTVENCIMENTO)
    ";
    
    const CLEAR_ORDER_STANDARTS = "
        DELETE FROM VALIDACAOADQ
        WHERE NRADQUIRENTE    = :NRADQUIRENTE
            AND   NRVALIDACAOADQ  = :NRVALIDACAOADQ
    ";
    
    const CLEAR_ESTABELEC_STANDARTS = "
        DELETE FROM VALIDACAOADQEST
        WHERE NRADQUIRENTE = :NRADQUIRENTE
            AND   NRESTABELEC  = :NRESTABELEC
    ";
    
    const CLEAR_ORDER_STANDARTS_EST = "
        DELETE FROM VALIDACAOADQEST
        WHERE NRADQUIRENTE    = :NRADQUIRENTE
            AND   NRVALIDACAOADQEST  = :NRVALIDACAOADQEST
            AND   NRESTABELEC  = :NRESTABELEC
    ";
    
    const SAVE_TECNOLOGIA_ADQ = "
        UPDATE TECNOLOGIAADQ
            SET NRTIPOTECNOLOG = :NRTIPOTECNOLOG,
            VRALUGUEL = :VRALUGUEL
        WHERE NRORG = :NRORG
            AND NRTECNOLOGADQ = :NRTECNOLOGADQ
            AND NRADQUIRENTE = :NRADQUIRENTE
    ";
    
    const INSERT_TECNOLOGIA_ADQ = "
        INSERT INTO TECNOLOGIAADQ
            (NRADQUIRENTE, NRTECNOLOGADQ, NRTIPOTECNOLOG, VRALUGUEL, NRORG, IDATIVO, DTULTATU, NRORGULTATU,
            CDOPERULTATU)
        VALUES
            (:NRADQUIRENTE, :NRTECNOLOGADQ, :NRTIPOTECNOLOG, :VRALUGUEL, :NRORG, :IDATIVO, :DTULTATU,
            :NRORGULTATU, :CDOPERULTATU)
    ";
    
    const GET_TECNOLOGIA_ADQ = "
        SELECT TA.NRADQUIRENTE, TA.NRTECNOLOGADQ, TA.NRTIPOTECNOLOG, TA.VRALUGUEL, T.NMTIPOTECNOLOG 
        FROM TECNOLOGIAADQ TA
        JOIN TIPOTECNOLOGIA T
            ON TA.NRTIPOTECNOLOG = T.NRTIPOTECNOLOG
        WHERE TA.NRORG = :NRORG
            AND TA.NRADQUIRENTE = :NRADQUIRENTE
            AND TA.NRESTABELEC IS NULL
    ";
    
    const DELETE_TECNOLOGIA_ADQ = "
        DELETE FROM TECNOLOGIAADQ
        WHERE NRORG = :NRORG
            AND IDATIVO = :IDATIVO
            AND NRTIPOTECNOLOG = :NRTIPOTECNOLOG
            AND NRADQUIRENTE = :NRADQUIRENTE
    ";
    
    const CHECK_EXISTS_TEC_ADQ = "
        SELECT COUNT(*) NR
        FROM TECNOLOGIAADQ TA
        JOIN TIPOTECNOLOGIA T
            ON TA.NRTIPOTECNOLOG = T.NRTIPOTECNOLOG
        WHERE T.NRTIPOTECNOLOG = :NRTIPOTECNOLOG
            AND TA.NRADQUIRENTE = :NRADQUIRENTE
            AND NRTECNOLOGADQ <> :NRTECNOLOGADQ
            AND NRESTABELEC IS NULL
    ";
    
    const SAVE_TECNOLOGIA_ADQ_EST = "
        UPDATE TECNOLOGIAADQ
            SET NRESTABELEC = :NRESTABELEC,
            VRALUGUEL = :VRALUGUEL
        WHERE NRORG = :NRORG
            AND NRTECNOLOGADQ = :NRTECNOLOGADQ
            AND NRTIPOTECNOLOG = :NRTIPOTECNOLOG
            AND NRADQUIRENTE = :NRADQUIRENTE
    ";
    
    const ISNERT_TECNOLOGIA_ADQ_EST = "
        INSERT INTO TECNOLOGIAADQ
            (NRESTABELEC, NRADQUIRENTE, NRTECNOLOGADQ, NRTIPOTECNOLOG, VRALUGUEL, NRORG, IDATIVO, DTULTATU,
            NRORGULTATU, CDOPERULTATU)
        VALUES
            (:NRESTABELEC, :NRADQUIRENTE, :NRTECNOLOGADQ, :NRTIPOTECNOLOG, :VRALUGUEL, :NRORG, :IDATIVO,
            :DTULTATU, :NRORGULTATU, :CDOPERULTATU)
    ";
    
    const GET_TECNOLOGIA_ADQ_EST = "
        SELECT TA.NRTIPOTECNOLOG, TA.NRTECNOLOGADQ, T.NMTIPOTECNOLOG, TA.NRADQUIRENTE, E.NRESTABELEC, 
            E.CDESTABELEC|| ' - ' || E.NMESTABELEC LABELESTABELEC, TA.VRALUGUEL
        FROM TECNOLOGIAADQ TA
        JOIN ESTABELECIMENTO E
            ON E.NRESTABELEC = TA.NRESTABELEC
        JOIN TIPOTECNOLOGIA T
            ON T.NRTIPOTECNOLOG = TA.NRTIPOTECNOLOG
        WHERE TA.NRORG = :NRORG
            AND TA.NRADQUIRENTE = :NRADQUIRENTE
            AND TA.NRTIPOTECNOLOG = :NRTIPOTECNOLOG
    ";
    
    const DELETE_TECNOLOGIA_ADQ_EST = "
        DELETE FROM TECNOLOGIAADQ
        WHERE NRORG = :NRORG
            AND IDATIVO = :IDATIVO
            AND NRTECNOLOGADQ = :NRTECNOLOGADQ
            AND NRADQUIRENTE  = :NRADQUIRENTE
            AND NRESTABELEC  = :NRESTABELEC
    ";
    
    const CHECK_EXISTS_TEC_ADQ_EST = "
        SELECT COUNT(*) NR
        FROM TECNOLOGIAADQ TA
        JOIN TIPOTECNOLOGIA T
            ON TA.NRTIPOTECNOLOG = T.NRTIPOTECNOLOG
        WHERE T.NRTIPOTECNOLOG = :NRTIPOTECNOLOG
            AND TA.NRADQUIRENTE = :NRADQUIRENTE
            AND NRESTABELEC = :NRESTABELEC
            AND NRTECNOLOGADQ <> :NRTECNOLOGADQ
    ";
    
    const GET_ADQUIRESTEN_SERIES = "
        SELECT F.CDINSCESTA, F.CDINSCMUNI, F.CDSERIE, F.CDEMPRESA
        FROM FILIAL F LEFT JOIN ESTABELECIMENTO E
            ON F.NRINSJURFILI = E.NRCNPJESTABELEC
        WHERE F.NRORG = :NRORG
            AND E.NRESTABELEC = :NRESTABELEC
    ";
    
    const GET_CONTCORR_EMPRESA = "
        SELECT CDCONTCORR, CDBANCO
        FROM CONTCORR
        WHERE NRORG = :NRORG
            AND CDEMPRESA = :CDEMPRESA
    ";
    
    const GET_INSC_VALUES = "
        SELECT F.CDINSCMUNI, F.CDINSCESTA, F.CDEMPRESA
        FROM ESTABELECIMENTO E, FILIAL F, EMPRESA P
        WHERE E.NRORG = :NRORG
            AND E.NRESTABELEC = :NRESTABELEC
            AND F.CDFILIAL = E.CDFILIAL
            AND F.CDEMPRESA = P.CDEMPRESA
    ";
    
    const VALIDATE_ESTABELEC = "
        SELECT COUNT(*) COUNT
        FROM PARAMFINESTADQ
        WHERE NRORG = :NRORG
            AND NRESTABELEC = :NRESTABELEC
            AND NRADQUIRENTE = :NRADQUIRENTE
    ";
    
    const FILTER_ADQ_FINAC_ROW = "
        SELECT P.NRPARAMFINESTADQ, P.NRESTABELEC , E.NMESTABELEC , P.NRADQUIRENTE, P.CDEMPRESA, EM.NMEMPRESA,
            P.CDINSCESTA, P.CDINSCMUNI, P.CDSERIE, S.DSSERIE, P.CDREDUCONT, CONT.CDCONTCORR, B.NMBANCO, 
            CONT.CDAGENCIA, CONT.CDBANCO, P.CDTPCTRECEB, TCR.DSTPCTRECEB, P.CDAJUCTREC, TAR.DSAJUCTREC, 
            p.CDTPDEBIBANC, TDB.DSTPDEBIBANC, P.CDTPDBDEBGER, TD.DSTPDEBIBANC DSTPDBDEBGER, P.CDCLIENTE, 
            C.NMRAZSOCCLIE, P.NRORG, P.CDTIPOOPER, P.IDENTRSAIDOP, TOA.NMTIPOOPER, B.CDPICTCONT, B.CDPICTAGEN,
            P.CDTPCREDBANC
        FROM PARAMFINESTADQ P LEFT JOIN CONTCORR CONT
            ON P.CDREDUCONT = CONT.CDREDUCONT
        LEFT JOIN TIPOCTRECEBER TCR
            ON P.CDTPCTRECEB = TCR.CDTPCTRECEB
        LEFT JOIN TIPOAJRECEBER TAR
            ON P.CDAJUCTREC = TAR.CDAJUCTREC
        LEFT JOIN TPDEBIBANC TDB
            ON P.CDTPDEBIBANC = TDB.CDTPDEBIBANC
        LEFT JOIN TPDEBIBANC TD
            ON P.CDTPDBDEBGER = TD.CDTPDEBIBANC
        LEFT JOIN TIPOOPERAC TOA
            ON P.CDTIPOOPER = TOA.CDTIPOOPER
            AND P.IDENTRSAIDOP = TOA.IDENTRSAIDOP
        LEFT JOIN SERIENF S
            ON P.CDSERIE = S.CDSERIE
            AND P.CDINSCMUNI = S.CDINSCMUNI
            AND P.CDINSCESTA = S.CDINSCESTA
        LEFT JOIN CLIENTE C
            ON P.CDCLIENTE = C.CDCLIENTE
        LEFT JOIN BANCO B
            ON CONT.CDBANCO = B.CDBANCO
        LEFT JOIN TPCREDBANC TCB
            ON TCB.CDTPCREDBANC = P.CDTPCREDBANC, ESTABELECIMENTO E, EMPRESA EM
        WHERE P.NRORG = :NRORG
            AND P.NRADQUIRENTE = :NRADQUIRENTE
            AND P.NRESTABELEC = :NRESTABELEC
            AND P.NRESTABELEC = E.NRESTABELEC
            AND P.CDEMPRESA = EM.CDEMPRESA
            ORDER BY P.NRESTABELEC
    ";
    
    const INSERT_LOG_ADQ_FINAC = "
        INSERT INTO LOGFINESTADQ
            (NRLOGFINESTADQ, NRADQUIRENTE, NRESTABELEC, DTOPERACAO, CDOPERADOR, IDTIPO, DSINFANTIGA, DSINFNOVA)
        VALUES
            (:NRLOGFINESTADQ, :NRADQUIRENTE, :NRESTABELEC, TO_CHAR(SYSDATE, 'DD/MM/YYYY HH24:MI:SS'),
            :CDOPERADOR, :IDTIPO, :DSINFANTIGA, :DSINFNOVA)
    ";
    
    const GET_PROD_ADQ = "
        SELECT PR.NRPRODUTOADQ, PR.CDPRODUTOADQ, PR.CDPRODADQEXT, PR.NMPRODUTOADQ, PR.CDTIPORECE, 
            TR.NMTIPORECE, PR.VRTOLERANCIA, PR.IDATIVO, PR.NRORG, PR.NRBANDEIRAVAN, 
            BAND.NMBANDEIRA, BAND.CDBANDEIRA, 'Sim' ATIVO, PR.IDVISIVEL   
        FROM PRODUTOADQ PR 
        LEFT JOIN BANDEIRAVAN BAND 
            ON PR.NRBANDEIRAVAN = BAND.NRBANDEIRAVAN 
        LEFT JOIN TIPORECE TR 
            ON PR.CDTIPORECE = TR.CDTIPORECE 
        WHERE PR.NRORG = :NRORG 
            AND PR.IDATIVO = 'S'
            ORDER BY NMPRODUTOADQ
    ";
    
    const GET_PRODUTO_GER = "
        SELECT PR.NRPRODUTOADQ, PR.CDPRODUTOADQ, PR.CDPRODADQEXT, PR.NMPRODUTOADQ, PR.CDTIPORECE, 
            TR.NMTIPORECE, PR.VRTOLERANCIA, PR.IDATIVO, PR.NRORG, PR.NRBANDEIRAVAN, 
            BAND.NMBANDEIRA, BAND.CDBANDEIRA, 'Sim' ATIVO, PR.IDVISIVEL   
        FROM PRODUTOADQ PR 
        LEFT JOIN BANDEIRAVAN BAND 
            ON PR.NRBANDEIRAVAN = BAND.NRBANDEIRAVAN 
        LEFT JOIN TIPORECE TR 
            ON PR.CDTIPORECE = TR.CDTIPORECE 
        WHERE PR.NRORG = :NRORG
            AND UPPER(PR.CDPRODUTOADQ|| ' - ' ||PR.NMPRODUTOADQ) LIKE UPPER(:LABELPRODUTOADQ)
            AND PR.IDATIVO = 'S' 
            ORDER BY NMPRODUTOADQ
    ";
    
    const GET_PRODUTOS = "
        SELECT PR.NRPRODUTOADQ, PR.CDPRODUTOADQ, PR.CDPRODADQEXT, PR.NMPRODUTOADQ, PR.CDTIPORECE, 
            TR.NMTIPORECE, PR.CDPRODUTOADQ|| ' - ' ||PR.NMPRODUTOADQ LABELPRODUTOADQ, 
            PR.VRTOLERANCIA, PR.IDATIVO, PR.NRORG, PR.NRBANDEIRAVAN, BAND.NMBANDEIRA, 
            BAND.CDBANDEIRA, PR.NRDIASVENC, 'Sim' ATIVO, PR.IDVISIVEL, 
            DECODE (PR.IDVISIVEL, 'S', 'Sim' , 'Não') LBIDVISIVEL
        FROM PRODUTOADQ PR 
        LEFT JOIN BANDEIRAVAN BAND 
            ON PR.NRBANDEIRAVAN = BAND.NRBANDEIRAVAN 
        LEFT JOIN TIPORECE TR 
            ON PR.CDTIPORECE = TR.CDTIPORECE
        WHERE PR.NRORG = :NRORG 
            AND ((INSTR ( UPPER(PR.NMPRODUTOADQ || PR.CDTIPORECE || TR.NMTIPORECE || 
                DECODE (PR.IDVISIVEL, 'S', 'Sim' , 'Não')), 
                UPPER(:ALL_FIELDS)) <> 0) OR (:TALL_FIELDS = 'T'))
            AND ((INSTR (:NRPRODUTOADQ, '|'||TO_CHAR(NRPRODUTOADQ)||'|') > 0) 
                OR ('T' = :TNRPTODUTOADQ))
            AND ((INSTR (:CDTIPORECE, '|'||TO_CHAR(PR.CDTIPORECE)||'|') > 0) 
                OR ('T' = :TCDTIPORECE))
            AND PR.IDATIVO = 'S' 
            ORDER BY NMPRODUTOADQ
    ";
    
    const FETCH_TIPO_RECE = "
        SELECT PR.CDTIPORECE, TR.NMTIPORECE, PR.NMPRODUTOADQ
        FROM PRODUTOADQ PR, TIPORECE TR
        WHERE PR.CDTIPORECE = :CDTIPORECE
            AND PR.CDTIPORECE = TR.CDTIPORECE
    ";
    
    const SAVE_PRODUCT = "
        UPDATE PRODUTOADQ 
            SET VRTOLERANCIA = :VRTOLERANCIA, 
                DTULTATU = :DTULTATU,
                NRORGULTATU = :NRORGULTATU,
                CDOPERULTATU = :CDOPERULTATU,
                NRBANDEIRAVAN = :NRBANDEIRAVAN,
                IDVISIVEL    = :IDVISIVEL,
                NRDIASVENC    = :NRDIASVENC
        WHERE NRORG = :NRORG 
                AND IDATIVO = :IDATIVO
                AND NRPRODUTOADQ = :NRPRODUTOADQ
                AND CDPRODUTOADQ = :CDPRODUTOADQ
    ";
    
    const SAVE_TYPE_UPDATE_ADQ = "
        UPDATE TAXAADQPROD
            SET VRTAXAADM = :VRTAXAADM,
                DTULTATU = :DTULTATU,
                NRORGULTATU = :NRORGULTATU,
                CDOPERULTATU = :CDOPERULTATU,
                NRDIASVENC = :NRDIASVENC
        WHERE NRORG = :NRORG
                AND IDATIVO = :IDATIVO
                AND NRADQUIRENTE = :NRADQUIRENTE
                AND NRPRODUTOADQ = :NRPRODUTOADQ
                AND NRTAXAADQPROD = :NRTAXAADQPROD
                AND NRESTABELEC IS NULL
    ";
    
    const SAVE_TYPE_INSERT_ADQ = "
        INSERT INTO TAXAADQPROD
            (NRTAXAADQPROD, NRADQUIRENTE, NRPRODUTOADQ, VRTAXAADM, NRORG, IDATIVO, DTULTATU,
                NRORGULTATU, CDOPERULTATU, NRDIASVENC)
        VALUES
            (:NRTAXAADQPROD, :NRADQUIRENTE, :NRPRODUTOADQ, :VRTAXAADM, :NRORG, :IDATIVO, :DTULTATU,
                :NRORGULTATU, :CDOPERULTATU, :NRDIASVENC)
    ";
    
    const GET_NRSEQUENCIAL_FROM_TAXAA_ADQ_PROD = "
        SELECT NRTAXAADQPROD
        FROM TAXAADQPROD
        WHERE NRORG = :NRORG
            AND IDATIVO = :IDATIVO
            ORDER BY NRTAXAADQPROD
    ";
    
    const CHECK_ROW_IS_NOT_NULL = "
        SELECT NRTAXAADQPROD
        FROM TAXAADQPROD
        WHERE NRADQUIRENTE = :NRADQUIRENTE
            AND NRPRODUTOADQ = :NRPRODUTOADQ
            AND NRORG = :NRORG
            AND IDATIVO = :IDATIVO
            AND NRESTABELEC IS NULL
    ";
    
    const SAVE_ESTABELEC = "
        INSERT INTO TAXAADQPROD
            (NRADQUIRENTE, NRPRODUTOADQ, NRESTABELEC, VRTAXAADM, NRTAXAADQPROD, NRORG, IDATIVO,
                DTULTATU, NRORGULTATU, CDOPERULTATU)
        VALUES
            (:NRADQUIRENTE, :NRPRODUTOADQ, :NRESTABELEC, :VRTAXAADM, :NRTAXAADQPROD, :NRORG,
                :IDATIVO, :DTULTATU, :NRORGULTATU, :CDOPERULTATU)
    ";
    
    const GET_ESTABELEC_FROM_TAXA_ADQ_PROD = "
        SELECT *
        FROM TAXAADQPROD
        WHERE NRESTABELEC = :NRESTABELEC
            AND NRADQUIRENTE = :NRADQUIRENTE
            AND NRPRODUTOADQ = :NRPRODUTOADQ
            AND NRORG = :NRORG
            AND IDATIVO = :IDATIVO
    ";
    
    const GET_ESTABELEC_FROM_TAXA_ADQ_PROD_EDIT = "
        SELECT *
        FROM TAXAADQPROD
        WHERE NRESTABELEC = :NRESTABELEC
            AND NRADQUIRENTE = :NRADQUIRENTE
            AND NRPRODUTOADQ = :NRPRODUTOADQ
            AND NRTAXAADQPROD <> :NRTAXAADQPROD
            AND NRORG = :NRORG
            AND IDATIVO = :IDATIVO
    ";
    
    const IS_TOTAL_ESTABELEC = "
        SELECT DECODE(
            EST.CDESTABELEC|| ' - ' ||EST.NMESTABELEC, ' - ', 'Todos',
            EST.CDESTABELEC|| ' - ' ||EST.NMESTABELEC) LABELESTABELEC  
        FROM TAXAADQPROD TAP 
        LEFT JOIN ESTABELECIMENTO EST 
            ON TAP.NRESTABELEC = EST.NRESTABELEC, PRODUTOADQ PRO 
        WHERE TAP.NRORG = :NRORG 
            AND TAP.IDATIVO = :IDATIVO 
            AND TAP.NRPRODUTOADQ = PRO.NRPRODUTOADQ 
            AND TAP.NRADQUIRENTE = :NRADQUIRENTE 
            AND TAP.NRPRODUTOADQ = :NRPRODUTOADQ 
            ORDER BY TAP.NRTAXAADQPROD
    ";
    
    const SAVE_EDIT_ESTABELEC = "
        UPDATE TAXAADQPROD
            SET VRTAXAADM = :VRTAXAADM,
                NRESTABELEC = :NRESTABELEC,
                DTULTATU = :DTULTATU,
                NRORGULTATU = :NRORGULTATU,
                CDOPERULTATU = :CDOPERULTATU
        WHERE NRORG = :NRORG
                AND IDATIVO = :IDATIVO
                AND NRTAXAADQPROD = :NRTAXAADQPROD
                AND NRADQUIRENTE = :NRADQUIRENTE
                AND NRPRODUTOADQ = :NRPRODUTOADQ
    ";
    
    const SAVE_EDIT_ESTABELEC_TYPE_TWO = "
        UPDATE TAXAADQPROD
            SET VRTAXAADM = :VRTAXAADM,
                DTULTATU = :DTULTATU,
                NRORGULTATU = :NRORGULTATU,
                CDOPERULTATU = :CDOPERULTATU
        WHERE NRORG = :NRORG
                AND IDATIVO = :IDATIVO
                AND NRTAXAADQPROD = :NRTAXAADQPROD
                AND NRADQUIRENTE = :NRADQUIRENTE
                AND NRPRODUTOADQ = :NRPRODUTOADQ
    ";
    
    const REMOVE_ESTABELEC = "
        DELETE FROM TAXAADQPROD
        WHERE NRORG = :NRORG
            AND IDATIVO = :IDATIVO
            AND NRTAXAADQPROD = :NRTAXAADQPROD
            AND NRADQUIRENTE = :NRADQUIRENTE
            AND NRPRODUTOADQ = :NRPRODUTOADQ
            AND NRESTABELEC = :NRESTABELEC
    ";
    
    const REMOVE_TAXA_ADQ_PROD = "
        DELETE FROM TAXAADQPROD
        WHERE NRORG = :NRORG
            AND IDATIVO = :IDATIVO
            AND NRTAXAADQPROD = :NRTAXAADQPROD
            AND NRADQUIRENTE = :NRADQUIRENTE
            AND NRPRODUTOADQ = :NRPRODUTOADQ
    ";
    
    const REMOVE_PROD_ADQ = "
        DELETE FROM TAXAADQPROD
        WHERE NRORG = :NRORG
            AND IDATIVO = :IDATIVO
            AND NRTAXAADQPROD = :NRTAXAADQPROD
            AND NRADQUIRENTE = :NRADQUIRENTE
            AND NRPRODUTOADQ = :NRPRODUTOADQ
    ";
    
    const GET_NRSEQUENCIAL_FROM_ESTABELEC_TO_REMOVE = "
        SELECT NRTAXAADQPROD
        FROM TAXAADQPROD
        WHERE NRADQUIRENTE = :NRADQUIRENTE
            AND NRPRODUTOADQ = :NRPRODUTOADQ
            AND NRORG = :NRORG
            AND IDATIVO = :IDATIVO
    ";
    
    const GET_NRSEQUENCIAL_FROM_ESTABELEC_TO_REMOVE_EST = "
        SELECT NRTAXAADQPROD
        FROM TAXAADQPROD
        WHERE NRADQUIRENTE = :NRADQUIRENTE
            AND NRPRODUTOADQ = :NRPRODUTOADQ
            AND NRESTABELEC = :NRESTABELEC
            AND NRORG = :NRORG
            AND IDATIVO = :IDATIVO
    ";
    
    const GET_NRSEQUENCIAL_TO_REMOVE = "
        SELECT NRTAXAADQPROD
        FROM TAXAADQPROD
        WHERE NRADQUIRENTE = :NRADQUIRENTE
            AND NRPRODUTOADQ = :NRPRODUTOADQ
            AND NRESTABELEC IS NULL
            AND NRORG = :NRORG
            AND IDATIVO = :IDATIVO
    ";
    
    const GET_PERIOD_TAXA = "
        SELECT TX.NRTAXAPERADQ, TO_CHAR(TX.DTINICIAL, 'DD/MM/YYYY') DTINICIAL, 
            TO_CHAR(TX.DTFINAL, 'DD/MM/YYYY') DTFINAL, TX.VRTAXAADM 
        FROM TAXAPERADQ TX, PRODUTOADQ P, ADQUIRENTE A
        WHERE TX.NRADQUIRENTE = A.NRADQUIRENTE
            AND TX.NRPRODUTOADQ = P.NRPRODUTOADQ
            AND A.NRADQUIRENTE = :NRADQUIRENTE
            AND P.NRPRODUTOADQ = :NRPRODUTOADQ
    ";
    
    const GET_PERIOD_TAXA_ROW = "
        SELECT TX.NRTAXAPERADQ, TO_CHAR(TX.DTINICIAL, 'DD/MM/YYYY') DTINICIAL, 
            TO_CHAR(TX.DTFINAL, 'DD/MM/YYYY') DTFINAL, TX.VRTAXAADM 
        FROM TAXAPERADQ TX, PRODUTOADQ P, ADQUIRENTE A
        WHERE TX.NRADQUIRENTE = A.NRADQUIRENTE
            AND TX.NRPRODUTOADQ = P.NRPRODUTOADQ
            AND A.NRADQUIRENTE = :NRADQUIRENTE
            AND P.NRPRODUTOADQ = :NRPRODUTOADQ
            AND TX.NRTAXAPERADQ = :NRTAXAPERADQ
    ";
    
    const ALTERA_PEDIDO_TAXA = "
        UPDATE TAXAPERADQ
            SET DTINICIAL   = :DTINICIAL,
                DTFINAL         = :DTFINAL,
                VRTAXAADM       = :VRTAXAADM
        WHERE NRADQUIRENTE  = :NRADQUIRENTE
                AND   NRPRODUTOADQ  = :NRPRODUTOADQ
                AND   NRTAXAPERADQ  = :NRTAXAPERADQ
    ";
    
    const INSERIR_PERIODO_TAXA = "
        INSERT INTO TAXAPERADQ
            (NRTAXAPERADQ, NRADQUIRENTE, NRPRODUTOADQ, DTINICIAL, DTFINAL, VRTAXAADM) 
        VALUES
            (:NRTAXAPERADQ, :NRADQUIRENTE, :NRPRODUTOADQ, :DTINICIAL, :DTFINAL, :VRTAXAADM)
    ";
    
    
    const DELETAR_PERIODO_TAXA = "
        DELETE 
        FROM TAXAPERADQ
        WHERE NRADQUIRENTE = :NRADQUIRENTE
            AND NRPRODUTOADQ = :NRPRODUTOADQ
            AND NRTAXAPERADQ = :NRTAXAPERADQ
    ";  
    
    const VERIFICA_INTERVALO = "
        SELECT COUNT(*) QUANTIDADE
        FROM TAXAPERADQ
        WHERE (((:DTINICIAL BETWEEN DTINICIAL AND DTFINAL)
            OR (:DTFINAL BETWEEN DTINICIAL AND DTFINAL))
            OR ((DTINICIAL BETWEEN :DTINICIAL AND :DTFINAL)
            OR (DTFINAL BETWEEN :DTINICIAL AND :DTFINAL)))
            AND NRADQUIRENTE = :NRADQUIRENTE
            AND NRPRODUTOADQ = :NRPRODUTOADQ
    ";
    
    const VERIFICA_INTERVALO_ALTERAR = "
        SELECT COUNT(*) QUANTIDADE
        FROM TAXAPERADQ
        WHERE (((:DTINICIAL BETWEEN DTINICIAL AND DTFINAL)
            OR (:DTFINAL BETWEEN DTINICIAL AND DTFINAL))
            OR ((DTINICIAL BETWEEN :DTINICIAL AND :DTFINAL)
            OR (DTFINAL BETWEEN :DTINICIAL AND :DTFINAL)))
            AND NRADQUIRENTE = :NRADQUIRENTE
            AND NRPRODUTOADQ = :NRPRODUTOADQ
            AND NRTAXAPERADQ <> :NRTAXAPERADQ
    ";
    
    const REGISTER_EXISTS = "
        SELECT * FROM TAXAADQPARC 
        WHERE NRORG = :NRORG 
            AND NRADQUIRENTE = :NRADQUIRENTE
            AND NRPRODUTOADQ = :NRPRODUTOADQ
            AND QTPARCELA = :QTPARCELA
    ";
    
    const LEFT_GRID_SELECT = "
        SELECT RV.CDNSU, RV.NRAUTORIZACAO, TO_CHAR(RV.DTVENDA, 'DD/MM/YYYY') DTVENDA, P.NMPRODUTOADQ, RV.VRBRUTVENDA, RV.NRCONCLANC, 
            DECODE(RV.IDCONCILIADO, 'P', 'P', 'C') IDCONCILIADO, E.CDESTABELEC, E.NMESTABELEC, RV.NRCONCLANCPGTO, RV.NRRETVENDAADQ CHAVE, 
            A.NMADQUIRENTE, RV.VRLIQVENDA, RV.NRTERMINAL, TO_CHAR(RV.DTCREDITO, 'DD/MM/YYYY') DTCREDITO, RV.NRLANCTONF, E.CDFILIAL, 
            A.NRADQUIRENTE, LPAD(TO_CHAR(RV.NRPARCELA), 2, '0') AS NRPARCELA
        FROM RETVENDAADQ RV 
        LEFT JOIN CONCILIACAOLANC CON
            ON RV.NRCONCLANC = CON.NRCONCLANC, ADQUIRENTE A, PRODUTOADQ P, ESTABELECIMENTO E
        WHERE RV.NRADQUIRENTE = A.NRADQUIRENTE
            AND RV.NRPRODUTOADQ = P.NRPRODUTOADQ 
            AND RV.NRESTABELEC = E.NRESTABELEC
            AND RV.NRORG = :NRORG
            AND ((INSTR (:NRESTABELEC,  '|'||TO_CHAR(RV.NRESTABELEC)||'|') > 0) OR :TNRESTABELEC = 'T')
            AND ((INSTR (:NRADQUIRENTE, '|'||TO_CHAR(RV.NRADQUIRENTE)||'|') > 0) OR :TNRADQUIRENTE = 'T')
            AND ((INSTR (:NRPRODUTOADQ, '|'||TO_CHAR(RV.NRPRODUTOADQ)||'|') > 0) OR :TNRPRODUTOADQ = 'T')
            AND RV.DTVENDA BETWEEN :DTVENDA_MIN AND :DTVENDA_MAX
            AND ((UPPER(RV.CDNSU) LIKE UPPER('%'||:CDNSU||'%')) OR ('T' = :TCDNSU))
            AND ((INSTR (:STATUS, RV.IDCONCILIADO) > 0) OR ('T' = :TSTATUS))
            ORDER BY RV.DTVENDA, E.NMESTABELEC, E.CDESTABELEC, A.NMADQUIRENTE, P.NMPRODUTOADQ, DTCREDITO, RV.VRBRUTVENDA, RV.CDNSU
    ";
    
    const RIGHT_GRID_SELECT = "
        SELECT T.CDNSU, T.NRAUTORIZACAO, T.DTVENDA, T.NMPRODUTOADQ, T.VRBRUTVENDA, T.NRCONCLANC, T.IDCONCILIADO, T.NRCONCLANCPGTO, T.CHAVE, T.DTCREDITO,
            T.DRECEBE, T.NRLANCTONF, T.CDFILIALNF, T.CDFILIAL, T.NMFILIAL, (T.VRBRUTVENDA - (T.VRBRUTVENDA * (NVL(TF.VRTAXAADMFIL, T.VRTAXAADMI)/100))) AS VRLIQVENDA,
            T.NRPARCELA, T.NRPARCELAREC, T.NMTIPORECE, NVL(TF.CDCLIENTE, T.CDCLIENTE) AS CDCLIENTE, NVL(TF.CDTPCTRECEB, T.CDTPCTRECEB) AS CDTPCTRECEB, 
            NVL(TF.CDAJTXADMREC, T.CDAJTXADMREC) AS CDAJTXADMREC, T.CDTIPORECE, T.NRCONSMOVCAIXA, T.CDEMPRESA, T.NRSEQUMOVI, T.CDCAIXA, T.DTABERCAIX AS DTABERCAIX
        FROM (
            SELECT C.CDNSU, C.NRAUTORIZACAO, TO_CHAR(C.DTVENDA, 'DD/MM/YYYY') DTVENDA, P.NMPRODUTOADQ, C.VRVENDA VRBRUTVENDA, C.NRCONCLANC, 
                DECODE(C.IDCONCILIADO, 'P', 'P', 'C') IDCONCILIADO, null NRCONCLANCPGTO, C.NRCONSMOVCAIXA CHAVE, C.NRCONSMOVCAIXA, F.CDEMPRESA,
                TO_CHAR(NVL(C.DTVENCIMENTO, CNC_DATA_VENC(C.CDFILIAL, C.DTVENDA, NVL(P.NRDIASVENC, 0), C.CDTIPORECE)), 'DD/MM/YYYY') DTCREDITO,
                NVL(C.DTVENCIMENTO, CNC_DATA_VENC(C.CDFILIAL, C.DTVENDA, NVL(P.NRDIASVENC, 0), C.CDTIPORECE)) - C.DTVENDA AS DRECEBE, C.NRLANCTONF, C.CDFILIALNF, 
                EF.CDFILIAL, F.NMFILIAL, NVL(TPRECE.VRTAXAADMI, 0) VRTAXAADMI, C.NRPARCELA, TPRECE.NMTIPORECE, C.CDTIPORECE, TPRECE.CDCLIENTE, TPRECE.CDTPCTRECEB, 
                TPRECE.CDAJTXADMREC, CTR.NRPARCELAREC, C.NRSEQUMOVI, C.CDCAIXA, C.DTABERCAIX AS DTABERCAIX
            FROM CONSMOVCAIXA C 
            LEFT JOIN CONCILIACAOLANC CON
                ON C.NRCONCLANC = CON.NRCONCLANC
            LEFT JOIN CONTARECEBER CTR
                ON CTR.CDFILIAL = C.CDFILIALNF
                AND CTR.NRLANCTONF = C.NRLANCTONF
            LEFT JOIN TIPORECE TPRECE
                ON TPRECE.CDTIPORECE = C.CDTIPORECE
            LEFT JOIN TPRECEPRODADQ TP
                ON C.CDTIPORECE = TP.CDTIPORECE
            LEFT JOIN PRODUTOADQ P
                ON P.NRPRODUTOADQ = TP.NRPRODUTOADQ, (
                        SELECT DISTINCT CDFILIAL
                        FROM ESTABELECIMENTO
                        WHERE ((INSTR (:NRESTABELEC,  '|'||TO_CHAR(NRESTABELEC)||'|') > 0) OR :TNRESTABELEC = 'T')
                    ) EF
            JOIN FILIAL F
                        ON F.CDFILIAL = EF.CDFILIAL
                    WHERE C.CDFILIAL = EF.CDFILIAL
                        AND C.NRORG = :NRORG                  
                        AND ((INSTR (:NRPRODUTOADQ, '|'||TO_CHAR(P.NRPRODUTOADQ)||'|') > 0) OR :TNRPRODUTOADQ = 'T')
                        AND C.DTVENDA BETWEEN :DTVENDA_MIN AND :DTVENDA_MAX
                        AND ((UPPER(C.CDNSU) LIKE UPPER('%'||:CDNSU||'%')) OR ('T' = :TCDNSU))
                        AND ((INSTR (:STATUS, C.IDCONCILIADO) > 0) OR ('T' = :TSTATUS))
                        ORDER BY DTVENDA, F.NMFILIAL, P.NMPRODUTOADQ, C.VRVENDA, C.CDNSU
            ) T
        LEFT JOIN TIPORECEFILIAL TF
            ON TF.CDFILIAL = T.CDFILIAL
            AND TF.CDTIPORECE = T.CDTIPORECE
    ";
    
    const RIGHT_GRID_SELECT_VISIBLE_PRODUCTS = "
        SELECT T.CDNSU, T.NRAUTORIZACAO, T.DTVENDA, T.NMPRODUTOADQ, T.VRBRUTVENDA, T.NRCONCLANC, T.IDCONCILIADO, T.NRCONCLANCPGTO, T.CHAVE, T.DTCREDITO,
            T.DRECEBE, T.NRLANCTONF, T.CDFILIALNF, T.CDFILIAL, T.NMFILIAL, (T.VRBRUTVENDA - (T.VRBRUTVENDA * (NVL(TF.VRTAXAADMFIL, T.VRTAXAADMI)/100))) AS VRLIQVENDA,
            T.NRPARCELA, T.NRPARCELAREC, T.NMTIPORECE, T.ISNULL, NVL(TF.CDCLIENTE, T.CDCLIENTE) AS CDCLIENTE, NVL(TF.CDTPCTRECEB, T.CDTPCTRECEB) AS CDTPCTRECEB, 
            NVL(TF.CDAJTXADMREC, T.CDAJTXADMREC) AS CDAJTXADMREC, T.CDTIPORECE, T.NRCONSMOVCAIXA, T.CDEMPRESA, C.NRSEQUMOVI, C.CDCAIXA, C.DTABERCAIX AS DTABERCAIX
        FROM (
            SELECT * FROM (
                SELECT T.*, DECODE(T.PRODUTOS, 0, 'N', 'S') ISNULL 
                    FROM (
                        SELECT C.CDNSU, C.NRAUTORIZACAO, TO_CHAR(C.DTVENDA, 'DD/MM/YYYY') DTVENDA, P.NRPRODUTOADQ, NVL(P.NRPRODUTOADQ, 0) PRODUTOS, 
                                P.NMPRODUTOADQ, C.VRVENDA VRBRUTVENDA, C.NRCONCLANC, 
                                DECODE(C.IDCONCILIADO, 'P', 'P', 'C') IDCONCILIADO, null NRCONCLANCPGTO, C.NRCONSMOVCAIXA CHAVE, C.NRCONSMOVCAIXA,
                                TO_CHAR(NVL(C.DTVENCIMENTO, CNC_DATA_VENC(C.CDFILIAL, C.DTVENDA, NVL(P.NRDIASVENC, 0), C.CDTIPORECE)), 'DD/MM/YYYY') DTCREDITO,
                                NVL(C.DTVENCIMENTO, CNC_DATA_VENC(C.CDFILIAL, C.DTVENDA, NVL(P.NRDIASVENC, 0), C.CDTIPORECE)) - C.DTVENDA AS DRECEBE,
                                C.NRLANCTONF, C.CDFILIALNF, EF.CDFILIAL, F.NMFILIAL, NVL(TPRECE.VRTAXAADMI, 0) VRTAXAADMI, F.CDEMPRESA, C.NRPARCELA, 
                                TPRECE.NMTIPORECE, C.CDTIPORECE, TPRECE.CDCLIENTE, TPRECE.CDTPCTRECEB, TPRECE.CDAJTXADMREC, CTR.NRPARCELAREC, 
                                C.NRSEQUMOVI, C.CDCAIXA, C.DTABERCAIX AS DTABERCAIX
                        FROM CONSMOVCAIXA C 
                        LEFT JOIN CONCILIACAOLANC CON
                            ON C.NRCONCLANC = CON.NRCONCLANC
                        LEFT JOIN CONTARECEBER CTR
                            ON CTR.CDFILIAL = C.CDFILIALNF
                            AND CTR.NRLANCTONF = C.NRLANCTONF
                        LEFT JOIN TIPORECE TPRECE
                            ON TPRECE.CDTIPORECE = C.CDTIPORECE
                        LEFT JOIN TPRECEPRODADQ TP
                            ON C.CDTIPORECE = TP.CDTIPORECE
                        LEFT JOIN PRODUTOADQ P
                            ON P.NRPRODUTOADQ = TP.NRPRODUTOADQ, (
                                SELECT DISTINCT CDFILIAL
                                FROM ESTABELECIMENTO
                                WHERE ((INSTR (:NRESTABELEC,  '|'||TO_CHAR(NRESTABELEC)||'|') > 0) OR :TNRESTABELEC = 'T')
                            ) EF
                        JOIN FILIAL F
                            ON F.CDFILIAL = EF.CDFILIAL
                        WHERE C.CDFILIAL = EF.CDFILIAL
                            AND C.NRORG = :NRORG                  
                            AND ((INSTR (:NRPRODUTOADQ, '|'||TO_CHAR(P.NRPRODUTOADQ)||'|') > 0) OR :TNRPRODUTOADQ = 'T')
                            AND C.DTVENDA BETWEEN :DTVENDA_MIN AND :DTVENDA_MAX
                            AND ((UPPER(C.CDNSU) LIKE UPPER('%'||:CDNSU||'%')) OR ('T' = :TCDNSU))
                            AND ((INSTR (:STATUS, C.IDCONCILIADO) > 0) OR ('T' = :TSTATUS))
                            ORDER BY DTVENDA, F.NMFILIAL, P.NMPRODUTOADQ, C.VRVENDA, C.CDNSU
                    )T
                )Q
            WHERE Q.ISNULL = 'S' ) T
            LEFT JOIN TIPORECEFILIAL TF
                ON TF.CDFILIAL = T.CDFILIAL
                AND TF.CDTIPORECE = T.CDTIPORECE
    ";
    
    const SELECT_CONCILIACOES_PAGTO = "
        SELECT RF.CDNSU, TO_CHAR(RF.DTVENDA, 'DD/MM/YYYY') DTVENDA, RF.VRBRUTVENDA, null VRLIQVENDA, RF.VRLIQPGTO, null VRTAXAPREV, RF.VRCOBRADOTAXA, 
            DECODE(RF.NRCONCLANC, null, 'P', 'C') IDCONCILIADO, DECODE(RF.NRANTECIPACAO, NULL, 'N', 'A') IDSTATUSVENDA,
            DECODE(CON.IDTPCONCILIACAO, 'A', 'Automática', 'M', 'Manual', NULL, 'Não Conciliada') IDTIPOCONCILIACAO, RF.NRCONCLANC NRCONCLANC, 
            RF.NRCONCLANC NRCONCLANCPGTO, RF.NRRETFINANCADQ, null NRRETVENDAADQ
        FROM RETFINANCADQ RF LEFT JOIN CONCILIACAOLANC CON
            ON RF.NRCONCLANC = CON.NRCONCLANC
        WHERE RF.NRORG = :NRORG
            AND RF.NRESTABELEC = :NRESTABELEC
            AND RF.NRADQUIRENTE = :NRADQUIRENTE
            AND RF.DTVENDA BETWEEN :DTVENDA_MIN AND :DTVENDA_MAX
            AND ((UPPER(RF.CDNSU) LIKE UPPER('%'||:CDNSU||'%')) OR ('T' = :TCDNSU))
            AND (RF.VRBRUTVENDA >= REPLACE(:VALINICIAL, '%', '') OR 'U' = :UVALINICIAL)
            AND (RF.VRBRUTVENDA <= REPLACE(:VALFINAL, '%', '') OR 'U' = :UVALFINAL)
            AND ((INSTR (:STATUS, RF.IDCONCILIADO) > 0) OR ('T' = :TSTATUS))
            AND REPLACE(:TIPOPGTO, '%', '') = 'R'
        UNION ALL
            SELECT RV.CDNSU, TO_CHAR(RV.DTVENDA, 'DD/MM/YYYY') DTVENDA, RV.VRBRUTVENDA, RV.VRLIQVENDA, null VRLIQPGTO, RV.VRTAXAPREV VRTAXA, null VRCOBRADOTAXA, 
                DECODE(RV.NRCONCLANCPGTO, null, 'P', 'C') IDCONCILIADO, NULL IDSTATUSVENDA, 
                DECODE(CON.IDTPCONCILIACAO, 'A', 'Automática', 'M', 'Manual', NULL, 'Não Conciliada') IDTIPOCONCILIACAO, RV.NRCONCLANCPGTO NRCONCLANC, 
                RV.NRCONCLANCPGTO, null RETFINANCADQ, RV.NRRETVENDAADQ
            FROM RETVENDAADQ RV LEFT JOIN CONCILIACAOLANC CON
                ON RV.NRCONCLANC = CON.NRCONCLANC
            WHERE RV.NRORG = :NRORG
                AND RV.NRESTABELEC = :NRESTABELEC
                AND RV.NRADQUIRENTE = :NRADQUIRENTE
                AND RV.DTVENDA BETWEEN :DTVENDA_MIN AND :DTVENDA_MAX
                AND ((UPPER(RV.CDNSU) LIKE UPPER('%'||:CDNSU||'%')) OR ('T' = :TCDNSU))
                AND (RV.VRBRUTVENDA >= REPLACE(:VALINICIAL, '%', '') OR 'U' = :UVALINICIAL)
                AND (RV.VRBRUTVENDA <= REPLACE(:VALFINAL, '%', '') OR 'U' = :UVALFINAL)
                AND ((INSTR (:STATUS, RV.IDCONCILIADO) > 0) OR ('T' = :TSTATUS))
                AND REPLACE(:TIPOPGTO, '%', '') = 'V'
                AND RV.NRCONCLANC IS NOT NULL
                ORDER BY 2, 11, 1
    ";
    
    const SELECT_TAB_SIS_MOVIMENTACOES = "
        SELECT RV.CDNSU, RV.NRAUTORIZACAO, TO_CHAR(RV.DTVENDA, 'DD/MM/YYYY') DTVENDA, A.NMADQUIRENTE, P.NMPRODUTOADQ, RV.VRBRUTVENDA, RV.NRCONCLANC, 
            DECODE(RV.IDCONCILIADO, 'P', 'P', 'C') IDCONCILIADO, RV.NRCONCLANCPGTO, RV.NRRETVENDAADQ, CON.CDOPERINCLUSAO, 
            TO_CHAR(CON.DTCONCILIACAO, 'DD/MM/YYYY') DTCONCILIACAO, CON.IDTPCONCILIACAO, TO_CHAR(CON.DTULTATU, 'DD/MM/YYYY') DTULTATU
        FROM RETVENDAADQ RV 
        LEFT JOIN CONCILIACAOLANC CON
            ON RV.NRCONCLANC = CON.NRCONCLANC, ADQUIRENTE A, PRODUTOADQ P
        WHERE RV.NRADQUIRENTE = A.NRADQUIRENTE
            AND RV.NRPRODUTOADQ = P.NRPRODUTOADQ
            AND RV.NRORG = :NRORG
            AND ((RV.NRCONCLANC = :NRCONCLANC AND :ISNULL = 'N') OR (RV.NRCONCLANC IS NULL AND :ISNULL = 'S'))
            AND RV.DTVENDA BETWEEN :DTVENDA_MIN AND :DTVENDA_MAX
            AND (INSTR (:IDCONCILIADO, DECODE(RV.IDCONCILIADO, 'P', 'P', 'C')) > 0)
            ORDER BY CDNSU
    ";
    
    const SELECT_TAB_ADQ_MOVIMENTACOES = "
        SELECT C.CDNSU, C.NRAUTORIZACAO, TO_CHAR(C.DTVENDA, 'DD/MM/YYYY') DTVENDA, C.VRVENDA VRBRUTVENDA, C.NRCONCLANC, DECODE(C.IDCONCILIADO, 'P', 'P', 'C')
            IDCONCILIADO, C.NRCONSMOVCAIXA, CON.CDOPERINCLUSAO, TO_CHAR(CON.DTCONCILIACAO, 'DD/MM/YYYY') DTCONCILIACAO, CON.IDTPCONCILIACAO, 
            TO_CHAR(CON.DTULTATU, 'DD/MM/YYYY') DTULTATU
        FROM CONSMOVCAIXA C LEFT JOIN CONCILIACAOLANC CON
            ON C.NRCONCLANC = CON.NRCONCLANC
        WHERE C.NRORG = :NRORG
            AND ((C.NRCONCLANC = :NRCONCLANC AND :ISNULL = 'N') OR (C.NRCONCLANC IS NULL AND :ISNULL = 'S'))
            AND C.DTVENDA BETWEEN :DTVENDA_MIN AND :DTVENDA_MAX
            AND (INSTR (:IDCONCILIADO, DECODE(C.IDCONCILIADO, 'P', 'P', 'C')) > 0)
            ORDER BY CDNSU
    ";
    
    const SELECT_TAB_VND_MOVIMENTACOES = "
        SELECT RF.CDNSU, TO_CHAR(RF.DTVENDA, 'DD/MM/YYYY') DTVENDA, RF.VRBRUTVENDA, RF.VRLIQPGTO, RF.VRCOBRADOTAXA, 
            DECODE(RF.NRANTECIPACAO, NULL, 'N', 'A') IDANTECIPACAO, RF.NRCONCLANC, CON.CDOPERINCLUSAO, TO_CHAR(CON.DTCONCILIACAO, 'DD/MM/YYYY')
            DTCONCILIACAO, CON.IDTPCONCILIACAO, TO_CHAR(CON.DTULTATU, 'DD/MM/YYYY') DTULTATU, RF.NRRETFINANCADQ, RF.IDCONCILIADO
        FROM RETFINANCADQ RF LEFT JOIN CONCILIACAOLANC CON
            ON RF.NRCONCLANC = CON.NRCONCLANC
        WHERE RF.NRORG = :NRORG
            AND RF.NRADQUIRENTE = :NRADQUIRENTE
            AND ((RF.NRCONCLANC = :NRCONCLANC AND :ISNULL = 'N') OR (RF.NRCONCLANC IS NULL AND :ISNULL = 'S'))
            AND RF.DTVENDA BETWEEN :DTVENDA_MIN AND :DTVENDA_MAX
            AND (INSTR (:IDCONCILIADO, DECODE(RF.IDCONCILIADO, 'P', 'P', 'C')) > 0)
            ORDER BY CDNSU
    ";
    
    const SELECT_TAB_RET_MOVIMENTACOES = "
        SELECT RV.CDNSU, TO_CHAR(RV.DTVENDA, 'DD/MM/YYYY') DTVENDA, RV.VRBRUTVENDA, RV.VRLIQVENDA, RV.VRTAXAPREV, RV.NRCONCLANCPGTO, 
            CON.CDOPERINCLUSAO, TO_CHAR(CON.DTCONCILIACAO, 'DD/MM/YYYY') DTCONCILIACAO, CON.IDTPCONCILIACAO, 
            TO_CHAR(CON.DTULTATU, 'DD/MM/YYYY') DTULTATU, RV.NRRETVENDAADQ, DECODE(RV.NRCONCLANCPGTO, null, 'P', 'C') IDCONCILIADO
        FROM RETVENDAADQ RV LEFT JOIN CONCILIACAOLANC CON
            ON RV.NRCONCLANCPGTO = CON.NRCONCLANC
        WHERE RV.NRORG = :NRORG
            AND RV.NRADQUIRENTE = :NRADQUIRENTE
            AND ((RV.NRCONCLANCPGTO = :NRCONCLANCPGTO AND :ISNULL = 'N') OR (RV.NRCONCLANCPGTO IS NULL AND :ISNULL = 'S'))
            AND RV.DTVENDA BETWEEN :DTVENDA_MIN AND :DTVENDA_MAX
            AND (INSTR (:IDCONCILIADO, DECODE(RV.IDCONCILIADO, 'P', 'P', 'C')) > 0)
            ORDER BY CDNSU
    ";
    
    const SELECT_RET_VENDA_INFO = "
        SELECT RV.*, P.CDTIPORECE
        FROM RETVENDAADQ RV
        LEFT JOIN (SELECT MAX(T.CDTIPORECE) CDTIPORECE, T.NRPRODUTOADQ FROM TPRECEPRODADQ T GROUP BY T.NRPRODUTOADQ) P
            ON P.NRPRODUTOADQ =  RV.NRPRODUTOADQ
        WHERE RV.NRRETVENDAADQ = :NRRETVENDAADQ
            AND RV.NRORG = :NRORG
    ";
    
    const CHECK_ITEM_CORRECAO = "
        SELECT NRITEMCORRECAO
        FROM ITEMCORRECAO
        WHERE UPPER(DSITEMCORRECAO) LIKE UPPER(:DSITEMCORRECAO)
    ";
    
    const UPDATE_CONS_WITH_VND_VALUES = "
        UPDATE CONSMOVCAIXA
            SET CDNSU = :CDNSU,
                NRAUTORIZACAO = :NRAUTORIZACAO,
                CDTIPORECE = :CDTIPORECE,
                NRQTPARCELA = :NRQTPARCELA,
                NRPARCELA = :NRPARCELA,
                VRVENDA = :VRVENDA,
                DTVENDA = :DTVENDA,
                DTVENCIMENTO = :DTVENCIMENTO,
                IDSITUACAO = 'O'
        WHERE NRORG = :NRORG
            AND NRCONSMOVCAIXA = :NRCONSMOVCAIXA
    ";
    
    const APAGA_CONTAS_PREVISTAS_FROM_LANCCONT = "
        DELETE 
        FROM LANCCONT L
        WHERE EXISTS (
            SELECT 1
            FROM AJCTRECEBER A
            WHERE A.CDFILIAL = :CDFILIAL
                AND A.NRLANCTONF = :NRLANCTONF
                AND A.CDECTBAJREC = L.CDEMPRESA
                AND A.NRLCTBAJREC = L.NRLANCCONT
            )
    ";
    
    const APAGA_CONTAS_PREVISTAS_FROM_AJCTRECEBER = "
        DELETE
        FROM AJCTRECEBER
        WHERE CDFILIAL = :CDFILIAL
            AND NRLANCTONF = :NRLANCTONF
    ";
    
    const APAGA_CONTAS_PREVISTAS_FROM_CONTARECEBER = "
        DELETE
        FROM CONTARECEBER
        WHERE CDFILIAL = :CDFILIAL
            AND NRLANCTONF = :NRLANCTONF
    ";
    
    const APAGA_CONTAS_PREVISTAS_SELECT_BOLETRECEBER_WITH_CONTARECEBER = "
        SELECT DISTINCT B.NRLANBOLREC, B.CDFILIAL
        FROM BOLETRECEBER B, CONTARECEBER C
        WHERE B.CDFILIAL = C.CDFILIBOLREC
            AND B.NRLANBOLREC = C.NRLANBOLREC
            AND C.CDFILIAL = :CDFILIAL
            AND C.NRLANCTONF = :NRLANCTONF
    ";
    
    const APAGA_CONTAS_PREVISTAS_DELETE_BOLETRECEBER_WITH_NRLANBOLREC = "
        DELETE
        FROM BOLETRECEBER
        WHERE CDFILIAL = :CDFILIAL
            AND NRLANBOLREC = :NRLANBOLREC
    ";
    
    const APAGA_CONTAS_PREVISTAS_UPDATE_RETVENDAADQ = "
        UPDATE RETVENDAADQ
            SET CDFILIAL = NULL,
                NRLANCTONF = NULL
        WHERE CDFILIAL = :CDFILIAL
            AND NRLANCTONF = :NRLANCTONF
    ";
    
    const UPDATE_CONS_MOV_CAIXA_BEFORE_DELETE = "
        UPDATE CONSMOVCAIXA
            SET CDFILIALNF = NULL,
                NRLANCTONF = NULL
        WHERE CDFILIALNF = :CDFILIALNF
            AND NRLANCTONF = :NRLANCTONF
    ";
    
    const DELETE_FROM_NOTA_FISCAL = "
        DELETE
        FROM NOTAFISCAL
        WHERE CDFILIAL = :CDFILIAL
            AND NRLANCTONF = :NRLANCTONF
    ";
    
    const NULLIFY_ROWS_AT_RETVENDA = "
        UPDATE RETVENDAADQ
            SET NRCONCLANC = null,
            NRCONCLANCPGTO = null,
            IDCONCILIADO = 'P',
            IDSITUACAO = 'N'
        WHERE NRORG = :NRORG
            AND NRCONCLANC = :NRCONCLANC
    ";
    
    const NULLIFY_CONC_PAGTO_AT_RETVENDA = "
        UPDATE RETVENDAADQ
            SET NRCONCLANCPGTO = null,
            IDCONCILIADO = 'I',
            IDSITUACAO = 'C'
        WHERE NRORG = :NRORG
            AND NRCONCLANCPGTO = :NRCONCLANCPGTO
    ";
    
    const NULLIFY_ROWS_AT_RETFINANC = "
        UPDATE RETFINANCADQ
            SET NRCONCLANC = null,
            IDCONCILIADO = 'P',
            IDSITUACAO = 'N'
        WHERE NRORG = :NRORG
            AND NRCONCLANC = :NRCONCLANC
    ";
    
    const NULLIFY_ROWS_AT_CONSMOVCAIXA = "
        UPDATE CONSMOVCAIXA
            SET NRCONCLANC = null,
            IDCONCILIADO = 'P',
            IDSITUACAO = 'N'
        WHERE NRORG = :NRORG
            AND NRCONCLANC = :NRCONCLANC
    ";
    
    const DELETE_FROM_DIVCONCILIACAO_WITH_NRCONSMOVCAIXA = "
        DELETE FROM DIVCONCILIACAO
        WHERE NRORG = :NRORG
            AND NRCONCLANC = :NRCONCLANC
            AND NRCONSMOVCAIXA = :NRCONSMOVCAIXA
    ";

    const DELETE_FROM_DIVCONCILIACAO = "
        DELETE FROM DIVCONCILIACAO
        WHERE NRORG = :NRORG
            AND NRCONCLANC = :NRCONCLANC
    ";
    
    const DELETE_FROM_CONCILIACAOLANC = "
        DELETE FROM CONCILIACAOLANC
        WHERE NRORG = :NRORG
            AND NRCONCLANC = :NRCONCLANC
    ";
    
    const INSERT_AT_CONCILIACAOLANC = "
        INSERT INTO CONCILIACAOLANC
            (NRCONCLANC, DTCONCILIACAO, IDTPCONCILIACAO, NRDIVCONCILIACAO, NRORG,IDATIVO, DTINCLUSAO, DTULTATU, 
                NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU)
        VALUES 
            (:NRCONCLANC, TO_DATE(:DTCONCILIACAO, 'DD/MM/YYYY'), :IDTPCONCILIACAO, :NRDIVCONCILIACAO, :NRORG, :IDATIVO, 
                TO_DATE(:DTINCLUSAO, 'DD/MM/YYYY'), TO_DATE(:DTULTATU, 'DD/MM/YYYY'), :NRORGINCLUSAO, :CDOPERINCLUSAO, 
                :NRORGULTATU, :CDOPERULTATU)
    ";
    
    const DELETE_ITEMCORVENDA = "
        DELETE FROM ITEMCORVENDA
        WHERE NRORG = :NRORG
            AND NRCONSMOVCAIXA = :NRCONSMOVCAIXA
    ";
    
    const INSERT_ITEMCORVENDA = "
        INSERT INTO ITEMCORVENDA
            (NRITEMCORVENDA, NRCONSMOVCAIXA, NRITEMCORRECAO, VRANTIGO, VRNOVO, NRORG)
        VALUES 
            (:NRITEMCORVENDA, :NRCONSMOVCAIXA, :NRITEMCORRECAO, :VRANTIGO, :VRNOVO, :NRORG)
    ";
    
    const UPDATE_RETVENDAADQ = "
        UPDATE RETVENDAADQ
            SET NRCONCLANC = :NRCONCLANC,
                IDCONCILIADO = :IDCONCILIADO,
                IDSITUACAO = :IDSITUACAO
        WHERE NRRETVENDAADQ = :NRRETVENDAADQ
    ";
    
    const UPDATE_RETVENDAADQ_NRLANCTONF = "
        UPDATE RETVENDAADQ
            SET NRLANCTONF = :NRLANCTONF,
                CDFILIAL   = :CDFILIALNF
        WHERE NRRETVENDAADQ = :NRRETVENDAADQ
    ";
    
    const UPDATE_PGTO_RETVENDAADQ = "
        UPDATE RETVENDAADQ
            SET NRCONCLANCPGTO = :NRCONCLANCPGTO,
                IDCONCILIADO = :IDCONCILIADO,
                IDSITUACAO = :IDSITUACAO
        WHERE NRRETVENDAADQ = :NRRETVENDAADQ
    ";
    
    const UPDATE_CONSMOVCAIXA = "
        UPDATE CONSMOVCAIXA
            SET NRCONCLANC = :NRCONCLANC,
                IDCONCILIADO = :IDCONCILIADO,
                IDSITUACAO = :IDSITUACAO
        WHERE NRCONSMOVCAIXA = :CHAVE
    ";
    
    const UPDATE_RETFINANCADQ = "
        UPDATE RETFINANCADQ
            SET NRCONCLANC = :NRCONCLANC,
                IDCONCILIADO = :IDCONCILIADO,
                IDSITUACAO = :IDSITUACAO
        WHERE NRRETFINANCADQ = :NRRETFINANCADQ
    ";
    
    const GET_ERRORS = "
        SELECT CDERROTEMP, NRSEQCTBTEMP
        FROM ERROCTBTEMP
        WHERE CDEMPRESA = :CDEMPRESA
            AND NRLANCCTBTEMP = :NRLANCCTBTEMP
    ";
    
    const DELETE_ERROR_FROM_ERROCTBTEMP = "
        DELETE
        FROM ERROCTBTEMP
        WHERE CDEMPRESA = :CDEMPRESA
            AND NRLANCCTBTEMP = :NRLANCCTBTEMP
    ";
    
    const DELETE_ERROR_FROM_LANCCTBTEMP = "
        DELETE
        FROM LANCCTBTEMP
        WHERE CDEMPRESA = :CDEMPRESA
            AND NRLANCCTBTEMP = :NRLANCCTBTEMP
    ";
    
    const DELETE_ERROR_FROM_RATECTBTEMP = "
        DELETE
        FROM RATECTBTEMP
        WHERE CDEMPRESA = :CDEMPRESA
            AND NRLANCCTBTEMP = :NRLANCCTBTEMP
    ";
    
    const VERIFICA_GERAFINANC = "
        SELECT IDGERAFINANC 
        FROM ADQUIRENTE
        WHERE NRADQUIRENTE = :NRADQUIRENTE
    ";
    
    const GET_NAME_PRODUTOADQ = "
        SELECT NMPRODUTOADQ 
        FROM PRODUTOADQ
        WHERE NRPRODUTOADQ = :NRPRODUTOADQ
    ";
    
    const SEARCH_PARAMS_CNC_TIPODEB = "
        SELECT BUSCA_PARAMETRO_CNC(
            :P_NRESTABELEC,
            :P_NRADQUIRENTE,
            :P_NRPRODUTOADQ,
            :P_TIPOPARAM,
            :P_GRAVAERRO,
            :P_DTINICIAL,
            :P_DTFINAL) AS CDTPDEBIBANC 
        FROM DUAL
    ";
    
    const SEARCH_PARAMS_CNC_TIPOCRED = "
        SELECT BUSCA_PARAMETRO_CNC(
            :P_NRESTABELEC,
            :P_NRADQUIRENTE,
            :P_NRPRODUTOADQ,
            :P_TIPOPARAM,
            :P_GRAVAERRO,
            :P_DTINICIAL,
            :P_DTFINAL) AS CDTPCREDBANC 
        FROM DUAL
    ";
    
    const SEARCH_PARAMS_CNC_TIPOCONTA = "
        SELECT BUSCA_PARAMETRO_CNC(
            :P_NRESTABELEC,
            :P_NRADQUIRENTE,
            :P_NRPRODUTOADQ,
            :P_TIPOPARAM,
            :P_GRAVAERRO,
            :P_DTINICIAL,
            :P_DTFINAL) AS CDTPCTRECEB 
        FROM DUAL
    ";
    
    const SEARCH_PARAMS_CNC_TIPOAJUSTE = "
        SELECT BUSCA_PARAMETRO_CNC(
            :P_NRESTABELEC,
            :P_NRADQUIRENTE,
            :P_NRPRODUTOADQ,
            :P_TIPOPARAM,
            :P_GRAVAERRO,
            :P_DTINICIAL,
            :P_DTFINAL) AS CDAJUCTREC 
        FROM DUAL
    ";

    const SEARCH_PARAMS_CNC_TIPOOPER = "
        SELECT BUSCA_PARAMETRO_CNC(
            :P_NRESTABELEC,
            :P_NRADQUIRENTE,
            :P_NRPRODUTOADQ,
            :P_TIPOPARAM,
            :P_GRAVAERRO,
            :P_DTINICIAL,
            :P_DTFINAL) AS CDTIPOOPER 
        FROM DUAL
    ";
    
    const VERIFY_INFO_CONSMOV = "
        SELECT DISTINCT CONS.NRCONCLANC, CONS.NRCONSMOVCAIXA, CONS.CDFILIAL, CONS.CDFILIALNF, CONS.NRLANCTONF, CTR.CDTPCTRECEB, CTR.DTATUAVENREC, CONS.DTVENDA, 
            CONS.CDTIPORECE, NF.CDTIPOOPER, NF.CDEMPRESA CDEMPRESA_NF, NF.CDINSCESTA CDINSCESTA_NF, NF.CDINSCMUNI CDINSCMUNI_NF, NF.CDSERIE CDSERIE_NF, NF.CDCLIENTE,
            EST.CDEMPRESA CDEMPRESA_ESTABELEC, EST.CDINSCESTA CDINSCESTA_ESTABELEC, EST.CDINSCMUNI CDINSCMUNI_ESTABELEC, EST.CDSERIE CDSERIE_ESTABELEC, CONS.DTVENCIMENTO, 
            CTR.NRPARCELAREC, CONS.NRPARCELA, CONS.NRQTPARCELA AS NRQTPARCELA
        FROM CONSMOVCAIXA CONS
        JOIN NOTAFISCAL NF
            ON NF.CDFILIAL = CONS.CDFILIALNF
            AND NF.NRLANCTONF = CONS.NRLANCTONF
        JOIN CONTARECEBER CTR
            ON CTR.CDFILIAL = CONS.CDFILIALNF
            AND CTR.NRLANCTONF = CONS.NRLANCTONF
        JOIN ESTABELECIMENTO EST
            ON EST.CDFILIAL = CONS.CDFILIAL
        WHERE CONS.NRCONSMOVCAIXA = :NRCONSMOVCAIXA
            AND CONS.NRORG = :NRORG
    ";
    
    const UPDATE_NOTA_FISCAL = "
        UPDATE NOTAFISCAL
            SET CDEMPRESA  = :CDEMPRESA,
                CDINSCESTA = :CDINSCESTA,
                CDINSCMUNI = :CDINSCMUNI,
                CDSERIE    = :CDSERIE,
                CDTIPOOPER = :CDTIPOOPER,
                NRNOTAFISC = :NRNOTAFISC,
                CDCLIENTE  = :CDCLIENTE
        WHERE CDFILIAL = :CDFILIAL
            AND NRLANCTONF = :NRLANCTONF
    ";
    
    const UPDATE_CONTA_RECEBER = "
        UPDATE CONTARECEBER
            SET CDTPCTRECEB  = :CDTPCTRECEB,
                DTATUAVENREC = :DTATUAVENREC,
                IDREPFOSCNC  = :IDREPFOSCNC,
                DSCONTAREC   = REPLACE(DSCONTAREC, '(PROVISAO FOS/CONCILIADOR)-', '')
        WHERE CDFILIAL = :CDFILIAL
            AND NRLANCTONF = :NRLANCTONF
            AND NRPARCELAREC = :NRPARCELAREC
    ";
    
    const UPDATE_CONTA_RECEBER_GERAL = "
        UPDATE CONTARECEBER
            SET IDREPFOSCNC  = :IDREPFOSCNC,
                DSCONTAREC   = REPLACE(DSCONTAREC, '(PROVISAO FOS/CONCILIADOR)-', '')
        WHERE CDFILIAL = :CDFILIAL
            AND NRLANCTONF = :NRLANCTONF
            AND NRPARCELAREC = :NRPARCELAREC
    ";
    
    const FIND_NRESTABELEC = "
        SELECT NRESTABELEC 
        FROM ESTABELECIMENTO
        WHERE CDESTABELEC = :CDESTABELEC
    ";
    
    const FIND_NRPRODUTO = "
        SELECT NRPRODUTOADQ 
        FROM PRODUTOADQ
        WHERE NMPRODUTOADQ = :NMPRODUTOADQ
    ";
    
    const FIND_VENDAS_CONCILIADAS = "
        SELECT DISTINCT C.CDFILIAL, C.DTVENDA, C.CDTIPORECE, P.NRPRODUTOADQ
        FROM CONSMOVCAIXA C, RETVENDAADQ R, PRODUTOADQ P
        WHERE C.NRCONCLANC = :NRCONCLANC
            AND C.CDFILIALNF = R.CDFILIAL
            AND C.NRLANCTONF = R.NRLANCTONF
            AND C.NRCONCLANC = R.NRCONCLANC
            AND R.NRPRODUTOADQ = P.NRPRODUTOADQ
    ";
    
    const FIND_VENDAS_CONCILIADAS_OLD = "
        SELECT DISTINCT C.CDFILIAL, C.DTVENDA, P.CDTIPORECE, D.VRESPERADO, D.VRENCONTRADO
        FROM CONSMOVCAIXA C, RETVENDAADQ R, TIPODIVERGENCIA T, DIVCONCILIACAO D, PRODUTOADQ P
        WHERE C.NRCONCLANC = :NRCONCLANC
            AND C.CDFILIALNF = R.CDFILIAL
            AND C.NRLANCTONF = R.NRLANCTONF
            AND C.NRCONCLANC = R.NRCONCLANC
            AND D.NRCONSMOVCAIXA = C.NRCONSMOVCAIXA
            AND D.NRRETVENDAADQ = R.NRRETVENDAADQ
            AND D.NRTPDIVERGENCIA = T.NRTPDIVERGENCIA
            AND T.IDDIVERGENCIA = 'P'
            AND D.VRESPERADO = P.NRPRODUTOADQ
            AND TRIM(D.VRENCONTRADO) = TRIM(TO_CHAR(:NRPRODUTOADQ))
    ";
    
    const INSERT_DIVERGENCIA_CONCILIACAO = "
        INSERT INTO DIVCONCILIACAO
            (NRDIVCONCILIACAO, NRCONCLANC, NRTPDIVERGENCIA, NRRETVENDAADQ, NRCONSMOVCAIXA, NRORG, VRESPERADO, VRENCONTRADO)
        VALUES 
            (:NRDIVCONCILIACAO, :NRCONCLANC, :NRTPDIVERGENCIA, :NRRETVENDAADQ, :NRCONSMOVCAIXA, :NRORG, :VRESPERADO, :VRENCONTRADO)
        ";
    
    const CHECK_ITEM_DIVERGENCIA = "
        SELECT NRTPDIVERGENCIA 
        FROM TIPODIVERGENCIA
        WHERE UPPER(DSTIPODIV) LIKE UPPER(:DSTIPODIV)
    ";
    
    const VERIFICA_DATA_PERIODO_CONTABIL = "
        SELECT 1 
        FROM CONTOPECTBL
        WHERE CDEMPRESA = :CDEMPRESA
            AND :DTVENDA BETWEEN DTINICCONT AND DTFINACONT
    ";
    
    const VERIFICA_DATA_CONTROLE_FINANC = "
        SELECT TO_CHAR(TRUNC(DTINICIOINT), 'DD/MM/YYYY') DATA
        FROM CTRLDTFINCNC
    ";
    
    const VERIFICA_DATA_CONTROLE_FINANC_FILIAL = "
        SELECT TO_CHAR(TRUNC(DTINICIOINT), 'DD/MM/YYYY') DATA
        FROM CTRLDTFINCNCFIL
        WHERE CDFILIAL = :CDFILIAL
    ";
    
    const VERIFICA_EMPRESA_DATA_VENDA = "
        SELECT DISTINCT F.CDEMPRESA, CONS.DTVENDA 
        FROM CONSMOVCAIXA CONS, FILIAL F
        WHERE CONS.NRCONSMOVCAIXA = :NRCONSMOVCAIXA
            AND F.NRORG = CONS.NRORG
            AND CONS.CDFILIAL = F.CDFILIAL
            AND CONS.NRORG = :NRORG
    ";
    
    const DELETE_DIV_CONCILIACAO = "
        DELETE 
        FROM DIVCONCILIACAO
        WHERE NRORG = :NRORG
            AND NRCONSMOVCAIXA = :NRCONSMOVCAIXA
    ";
    
    const EXIST_BOLET_REC = "
        SELECT DISTINCT B.CDFILIAL, NRLANBOLREC, VRFINALBREC, NRPARCBOLREC
        FROM BOLETRECEBER B
        WHERE CDFILIAL = :CDFILIAL
            AND CDCLIENTE = :CDCLIENTE
            AND CDEMPRESA = :CDEMPRESA
            AND DTVENBOLREC = :DTVENBOLREC
            AND EXISTS (
                SELECT 1
                FROM CONTARECEBER C
                JOIN NOTAFISCAL NF
                    ON NF.CDFILIAL = C.CDFILIAL
                    AND NF.NRLANCTONF = C.NRLANCTONF
                JOIN CONSMOVCAIXA CONS
                    ON CONS.CDFILIALNF = NF.CDFILIAL
                    AND CONS.NRLANCTONF = NF.NRLANCTONF
                WHERE C.CDFILIBOLREC = B.CDFILIAL
                    AND C.NRLANBOLREC = B.NRLANBOLREC
                    AND C.CDTPCTRECEB = :CDTPCTRECEB
                    AND NF.IDSISTEMA = 'CNC'
                    AND CONS.IDCONCILIADO = 'C')
            AND ROWNUM = 1
            ORDER BY 2 DESC
    ";
    
    const RECALCULA_TOTAL_BOLETO = "
        SELECT C.CDFILIBOLREC, C.NRLANBOLREC, SUM(C.VRATUAREC) AS TOTALCONTAS
        FROM CONTARECEBER C
        WHERE C.CDFILIBOLREC = :CDFILIBOLREC
            AND C.NRLANBOLREC = :NRLANBOLREC
            GROUP BY C.CDFILIBOLREC, C.NRLANBOLREC
        ";
        
    const UPDATE_BOLETO_RECEBER = "
        UPDATE BOLETRECEBER
            SET VRFINALBREC = :VRFINALBREC, 
                VRBOLREC = :VRBOLREC,
                CDCLIENTE = :CDCLIENTE
        WHERE CDFILIAL = :CDFILIAL
            AND NRLANBOLREC = :NRLANBOLREC
    ";
    
    const GET_CDCLIENTE_BY_TIPORECE = "
        SELECT CDCLIENTE 
        FROM TIPORECE 
        WHERE CDTIPORECE = (SELECT MAX(TP.CDTIPORECE) 
                            FROM TPRECEPRODADQ TP 
                                JOIN (SELECT NRPRODUTOADQ FROM PRODUTOADQ WHERE NMPRODUTOADQ = :NMPRODUTOADQ) A 
                                ON TP.NRPRODUTOADQ = A.NRPRODUTOADQ)
    ";
    
    const VERIFY_CONTA_RECEBER_INFO = "
    SELECT CDFILIBOLREC, NRLANBOLREC, VRATUAREC, NRPARCELAREC, NRLANCTONF, CDFILIAL
    FROM CONTARECEBER
    WHERE NRLANCTONF = :NRLANCTONF
        AND  CDFILIAL  = :CDFILIAL
    ";
    
    const RECALCULA_BOLETO = "
        SELECT C.CDFILIBOLREC, C.NRLANBOLREC, C.NRSEQVENREC, C.NRPARCELAREC, SUM(C.VRATUAREC) AS TOTALCONTAS
        FROM CONTARECEBER C
        WHERE C.CDFILIBOLREC = :CDFILIBOLREC
            AND C.NRLANBOLREC = :NRLANBOLREC
            GROUP BY C.CDFILIBOLREC, C.NRLANBOLREC, C.NRSEQVENREC, C.NRPARCELAREC
    ";
    
    const VERIFY_BOLETO_RECEBER_INFO = "
        SELECT VRFINALBREC, CDFILIAL AS CDFILIBOLREC, NRLANBOLREC 
        FROM BOLETRECEBER
        WHERE CDFILIAL = :CDFILIBOLREC 
            AND NRLANBOLREC = :NRLANBOLREC
    ";
    
    const GET_MOV_CAIXA = "
        SELECT CDNSUHOSTTEF, VRMOVIVEND, CDTIPORECE, DTMOVIMCAIXA FROM MOVCAIXA
        WHERE CDFILIAL = :CDFILIAL 
            AND CDCAIXA = :CDCAIXA
            AND NRSEQUMOVI = :NRSEQUMOVI
            AND DTABERCAIX = :DTABERCAIX
    ";
    
    const UPDATE_CONSMOVCAIXA_DESCONCILIACAO = "    
        UPDATE CONSMOVCAIXA
        SET CDNSU = :CDNSU,
            VRVENDA = :VRVENDA,
            CDTIPORECE = :CDTIPORECE,
            DTVENDA = :DTVENDA,
            DTVENCIMENTO = :DTVENCIMENTO
        WHERE NRCONSMOVCAIXA = :NRCONSMOVCAIXA
            AND CDFILIAL  = :CDFILIAL
            AND CDCAIXA = :CDCAIXA
            AND NRSEQUMOVI  = :NRSEQUMOVI
            AND DTABERCAIX  = :DTABERCAIX
    ";
    
    const NULLIFY_BOLETO_RECEBER = "    
        UPDATE CONTARECEBER
        SET NRLANBOLREC = NULL,
            CDFILIBOLREC = NULL
        WHERE NRLANCTONF = :NRLANCTONF
            AND  CDFILIAL  = :CDFILIAL
    ";
    
    const CLEAR_BOLRECEB_FROM_CONTARECEB = "    
        UPDATE CONTARECEBER
            SET CDFILIBOLREC = NULL,
                NRLANBOLREC = NULL
        WHERE NRLANCTONF = :NRLANCTONF
            AND CDFILIAL   = :CDFILIAL
            AND NRPARCELAREC   = :NRPARCELAREC
    ";
    
    const CALC_NRDIASVENC = "         
        SELECT NVL(NVL(PR.NRDIASVENC, T.NRDIASADMI), 0) AS V_NRDIASVENC
        FROM TIPORECE T LEFT JOIN PARAVEND P
            ON P.CDFILIAL = :CDFILIAL
        LEFT JOIN PRODUTOADQ PR
            ON PR.CDTIPORECE = T.CDTIPORECE
        WHERE T.CDTIPORECE = :CDTIPORECE
    ";
    
    const VERIFY_DATAVENC = "
        SELECT CNC_DATA_VENC(:CDFILIAL, :DTVENDA, :NRDIASVENC, :CDTIPORECE) AS V_DTVENCIMENTO
        FROM DUAL
    ";
    
    const UPDATE_CONTA_RECEBER_BOL = "
        UPDATE CONTARECEBER
            SET CDFILIBOLREC = :CDFILIBOLREC,
            NRLANBOLREC  = :NRLANBOLREC
        WHERE NRLANCTONF = :NRLANCTONF
            AND CDFILIAL       = :CDFILIAL
            AND NRPARCELAREC   = :NRPARCELAREC
    ";
    
    const UPDATE_TPRECBOLETO = "
        UPDATE TPRECBOLETO
            SET VRTPRECBOLR = :VRTPRECBOLR
        WHERE NRLANBOLREC = :NRLANBOLREC
            AND CDFILIAL   = :CDFILIAL
    ";
    
    const DELETE_BOLETRECEBER = "
        DELETE
        FROM BOLETRECEBER
        WHERE CDFILIAL = :CDFILIAL
            AND NRLANBOLREC = :NRLANBOLREC
    ";
    
    const DELETE_TPRECBOLETO = "
        DELETE
        FROM TPRECBOLETO
        WHERE CDFILIAL = :CDFILIAL
            AND NRLANBOLREC = :NRLANBOLREC
    ";
    
    const UPDATE_BOLETO_CONTA = "
        UPDATE CONTARECEBER 
            SET CDFILIBOLREC = NULL, 
                NRLANBOLREC = NULL 
        WHERE CDFILIAL = :P_CDFILIAL 
            AND NRLANCTONF = :P_NRLANCTONF
    ";
    
    const VERIFY_INFO_TIPORECE = "
        SELECT NVL(P.CDREDUCONT, T.CDREDUCONT) CDREDUCONT
        FROM TIPORECE T, PARAVEND P
        WHERE T.CDTIPORECE = :CDTIPORECE
            AND P.CDFILIAL = :CDFILIAL
    ";
    
    const GET_CDCLIENTE = "
        SELECT CDCLIENTE 
        FROM ADQUIRENTE
        WHERE NRADQUIRENTE = :NRADQUIRENTE
    ";
    
    const UPDATE_CLIENTE_NF = "
        UPDATE NOTAFISCAL
        SET CDCLIENTE  = :CDCLIENTE
        WHERE CDFILIAL = :CDFILIAL
            AND NRLANCTONF = :NRLANCTONF
    ";
    
    const UPDATE_CONTRECEB_DESC = "
        UPDATE CONTARECEBER
            SET DSCONTAREC  = REPLACE(DSCONTAREC, '(PROVISAO FOS/CONCILIADOR)-', ''),
                IDREPFOSCNC = 'N'
        WHERE CDFILIAL   = :CDFILIALNF
            AND NRLANCTONF = :NRLANCTONF
            AND NRPARCELAREC   = :NRPARCELAREC
    ";
    
    const VERIFY_CONTRECEB = "
        SELECT 1 AS FLAGBOLETO
        FROM CONTARECEBER C
        WHERE C.CDFILIAL = :CDFILIAL
            AND C.NRLANCTONF = :NRLANCTONF
            AND C.IDSTATREC = 'B'
    ";
    
    const BUSCA_BOLETO = "
        SELECT NRLANBOLREC AS BOLETO
        FROM CONTARECEBER C
        WHERE C.CDFILIAL = :CDFILIAL
            AND C.NRLANCTONF = :NRLANCTONF
    ";
    
    const VERIFY_AJU_BOLETO = "
        SELECT 1 AS FLAGAJUSTE
        FROM AJBOLREC B
        WHERE B.CDFILIAL = :CDFILIAL
            AND B.NRLANBOLREC = :NRLANBOLREC
    ";
    
    const UPDATE_BOLETO_RECEBER_VALOR = "
        UPDATE BOLETRECEBER
            SET VRFINALBREC = :VRFINALBREC, 
                VRBOLREC = :VRBOLREC
        WHERE CDFILIAL = :CDFILIAL
            AND NRLANBOLREC = :NRLANBOLREC
    ";

    const VERIFY_CDCLIENTE_TIPORECE = "
        SELECT NVL(TF.CDCLIENTE, VENDA.CDCLIENTE) AS CDCLIENTE
            FROM (
                SELECT M.CDFILIAL, T.IDCONTAPREVCNC, M.CDTIPORECE, T.IDGERAFIN, P.CDREDUCONT AS CDREDUCONTP, T.CDREDUCONT AS CDREDUCONT, T.CDCLIENTE, T.CDTPCTRECEB
                    FROM TIPORECE T
                        JOIN CONSMOVCAIXA M
                            ON M.CDTIPORECE = T.CDTIPORECE
                        JOIN MOVCAIXA V
                            ON M.CDFILIAL = V.CDFILIAL
                            AND M.CDCAIXA = V.CDCAIXA
                            AND M.DTABERCAIX = V.DTABERCAIX
                            AND M.NRSEQUMOVI = V.NRSEQUMOVI
                        JOIN FILIAL F
                            ON F.CDFILIAL = V.CDFILIAL
                            AND F.CDFILIAL = M.CDFILIAL
                        JOIN PARAVEND P
                            ON F.CDFILIAL = P.CDFILIAL
                        JOIN CTRLDTFINCNC CT
                            ON M.NRORG = CT.NRORG
                        LEFT JOIN CTRLDTFINCNCFIL CTF
                            ON M.CDFILIAL = CTF.CDFILIAL
                    WHERE M.NRCONSMOVCAIXA = :NRCONSMOVCAIXA
                        AND NVL(P.CDSERIECNTREC, P.CDSERIE) IS NOT NULL
                        AND P.CDTPOPERCNTREC IS NOT NULL
                        AND F.CDINSCESTA IS NOT NULL
                        AND F.CDINSCMUNI IS NOT NULL
                        AND F.CDEMPRESA IS NOT NULL
                        AND P.IDENTRSAIDOP IS NOT NULL
                        AND T.CDAJTXADMREC IS NOT NULL
                        AND NVL(TRUNC(CTF.DTINICIOINT), TRUNC(CT.DTINICIOINT)) <= M.DTVENDA
                        AND NOT EXISTS (
                            SELECT 1
                                FROM NOTAFISCAL N
                                WHERE N.CDFILIAL = M.CDFILIALNF
                                    AND N.NRLANCTONF = M.NRLANCTONF
                        )
            ) VENDA 
            LEFT JOIN TIPORECEFILIAL TF
                ON TF.CDFILIAL = VENDA.CDFILIAL
                    AND TF.CDTIPORECE = VENDA.CDTIPORECE
            WHERE NVL(TF.IDCONTAREPFOS, VENDA.IDCONTAPREVCNC) = 'S'
                AND NVL(NVL(TF.IDGERAFINFIL, VENDA.IDGERAFIN), 'N') = 'N'
                AND NVL(VENDA.CDREDUCONTP, NVL(TF.CDREDUCONT, VENDA.CDREDUCONT)) IS NOT NULL
                AND NVL(TF.CDCLIENTE, VENDA.CDCLIENTE) IS NOT NULL
                AND NVL(TF.CDTPCTRECEB, VENDA.CDTPCTRECEB) IS NOT NULL
    ";
}
