<?php

namespace Teknisa\CNC\Services;
use Teknisa\Libs\Util\Environment;
use Teknisa\CNC\Utilities\UtilCNC;
use Teknisa\CNC\Factories\Cnc02700TaxaServEstabelecimentoFactory;

class Cnc02700TaxaServEstabelecimentoService {
    protected $entityManager;
    protected $factory;
    protected $environment;
    protected $util;
    
    public function __construct (\Doctrine\ORM\EntityManager $entityManager, Environment $environment, Cnc02700TaxaServEstabelecimentoFactory $factory, UtilCNC $util) {
        $this->entityManager = $entityManager;
        $this->environment = $environment;
        $this->factory = $factory;
        $this->util = $util;
    }

    public function getEstabelecTaxaServ () {
        $result = $this->factory->getEstabelecTaxaServ(array(
            ':NRORG' => $this->environment->getNrOrgTrab()
        ));
        
        return $result;
    }
    
    public function getEstabelecTaxaServRow ($params) {
        $NRESTABELEC = isset($params[0]["value"]) ? $params[0]["value"] : $params['NRESTABELEC'];
        $result = $this->factory->getEstabelecTaxaServRow(array(
            ':NRORG' => $this->environment->getNrOrgTrab(),
            ':NRESTABELEC' => $NRESTABELEC
        ));
        
        return $result;
    }

    public function gettpAjustesServ () {
        $result = $this->factory->gettpAjustesServ(array(
            ':NRORG'     => $this->environment->getNrOrgTrab()
        ));
        
        return $result;
    }
    
    public function gettpAjusteAdm () {
        $result = $this->factory->gettpAjusteAdm(array(
            ':NRORG'        => $this->environment->getNrOrgTrab()
        ));
        
        return $result;
    }
    
    public function saveEstabelecTaxaServ ($row) {
        if(isset($row["VRPERCTXADMSERVEDIT"])){
            if(!!$row["VRPERCTXADMSERVEDIT"])
                $VRPERCTXADMSERV = $row["VRPERCTXADMSERVEDIT"];
            else {
                $VRPERCTXADMSERV = null;
            }
        } else {
            $VRPERCTXADMSERV = null;
        }
        if(isset($row["DSTPAJUCTTXADM"])){
            if(!!$row["DSTPAJUCTTXADM"])
                $CDTPAJUCTTXADM = $row["CDTPAJUCTTXADM"];
            else {
                $CDTPAJUCTTXADM = null;
            }
        }  else {
            $CDTPAJUCTTXADM = null;
        }
        if(isset($row["DSTPAJUCTTXSRV"])){
            if(!!$row["DSTPAJUCTTXSRV"])
                $CDTPAJUCTTXSRV = $row["CDTPAJUCTTXSRV"];
            else {
                $CDTPAJUCTTXSRV = null;
            }
        } else {
            $CDTPAJUCTTXSRV = null;
        }
        $this->factory->updateEstabelecTaxaServ(array(
            ":NRESTABELEC"     => $row['NRESTABELEC'],
            ":IDCTRLTXSERV"    => $row["IDCTRLTXSERV"],
            ":VRPERCTXADMSERV" => $VRPERCTXADMSERV,
            ":CDTPAJUCTTXADM"  => $CDTPAJUCTTXADM,
            ":CDTPAJUCTTXSRV"  => $CDTPAJUCTTXSRV
        ));
    }

}
